unit lepagew32;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Menus;

type
  Tflepage = class(TForm)
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    Memo2: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Memo3: TMemo;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label25: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label12: TLabel;
    Label8: TLabel;
    Bevel2: TBevel;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Label9: TLabel;
    Edit1: TEdit;
    Label10: TLabel;
    Edit2: TEdit;
    Label11: TLabel;
    Bevel1: TBevel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure go(Sender: TObject);
    procedure sortie_gamma(Sender: TObject);
    procedure sortie(Sender: TObject);
    procedure go_instru(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure sauve_maille(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  flepage: Tflepage;

implementation

{$R *.DFM}

uses
  mathhkl, instru;

var
  determinant , lattice_type : string[1];
  nb_sol                     : integer;

{---DLL lepage2-----------------------------------------------------------}
procedure lepage2;
                 far;stdcall;external 'lepage2.dll' index 1;


procedure relit_maille(var ier:integer);
//-------------------------------------
var
  s             : string;
  ca,cb,cc,vol  : real;
label 1;
begin
  with flepage do begin
    determinant:=trim(edit1.text);
    lattice_type:=uppercase(trim(edit2.text));
    s:=edit10.text;
    if(s = '')then goto 1;
    verif(s);
    val(s,cel[1],ier);
    if(ier <> 0)then begin
      erreur('Error on a');
      exit;
    end;
    s:=edit11.text;
    if(s = '')then goto 1;
    verif(s);
    val(s,cel[2],ier);
    if(ier <> 0)then begin
      erreur('Error on b');
      exit;
    end;
    s:=edit12.text;
    if(s = '')then goto 1;
    verif(s);
    val(s,cel[3],ier);
    if(ier <> 0)then begin
      erreur('Error on c');
      exit;
    end;
    s:=edit13.text;
    if(s = '')then goto 1;
    verif(s);
    val(s,cel[4],ier);
    if(ier <> 0)then begin
      erreur('Error on alpha');
      exit;
    end;
    s:=edit14.text;
    if(s = '')then goto 1;
    verif(s);
    val(s,cel[5],ier);
    if(ier <> 0)then begin
      erreur('Error on beta');
      exit;
    end;
    s:=edit15.text;
    if(s = '')then goto 1;
    verif(s);
    val(s,cel[6],ier);
    if(ier <> 0)then begin
      erreur('Error on gamma');
      exit;
    end;
1:  if (s = '')then begin
       ier:=1;
       exit;
    end;
    if (ier > 0)then exit;
    setmat;
    quel_systeme;
    if (systeme = 'CUBI')then s:='Cubic';
    if (systeme = 'TETR')then s:='Tetragonal';
    if (systeme = 'ORTH')then s:='Orthorhombic';
    if (systeme = 'HEXA')then s:='Hexagonal';
    if (systeme = 'RHOM')then s:='Rhomboedral';
    if (systeme = 'MONO')then s:='Monoclinic';
    if (systeme = 'TRIC')then s:='Triclinic';
    ca:=cos(cel[4]/57.2957);
    cb:=cos(cel[5]/57.2957);
    cc:=cos(cel[6]/57.2957);
    vol:=cel[1]*cel[2]*cel[3]*sqrt(1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc);
    str(vol:10:2,s);
  end;
end;

procedure Tflepage.go(Sender: TObject);
//-----------------------------------
var
  nomf            : textfile;
  s,ss,s1         : string;
  i,ier           : integer;
begin
 memo1.clear;
 memo2.clear;
 memo3.clear;

//Lecture de la maille
 relit_maille(ier);
 if (ier > 0)then exit;

 screen.cursor:=crHourGlass;
//Ecriture du fichier d'entre lepage.inp
 assignfile(nomf,'lepage.inp');
 rewrite(nomf);
 write(nomf,'CELL ');
 for i:=1 to 6 do write(nomf,cel[i]:10:4);
 writeln(nomf,' '+lattice_type);
 writeln(nomf,'SUPER '+determinant);
 writeln(nomf,'CALC');
 writeln(nomf,'QUIT');
 closefile(nomf);

 lepage2;

//Ecriture de la maille rduite;
 assignfile(nomf,'lepage.lis');
 reset(nomf);
 while not(eof(nomf)) do begin
   readln(nomf,s);
   if (pos('   INPUT CELL',s) > 0)then begin
     memo3.lines.add(s);
     for i:=1 to 2 do begin
       readln(nomf,s);
       memo3.lines.add(s);
     end;
     break;
   end;
 end;

//Ecriture des supercells
 ss:='=== TRANSFORMATION MATRIX: INPUT (A,B,C) TO CONVENTIONAL CELL';
 nb_sol:=0;
 while not(eof(nomf)) do begin
   readln(nomf,s);
   readln(nomf,s);

//Dtection de la matrice de transformation
   if (pos(ss,s) > 0)then begin
     readln(nomf,s);
     s1:='';
     for i:=1 to 3 do begin
       readln(nomf,s);
       s:=copy(s,9,18);
       s1:=s1+s;
     end;
   end;

//Dtection de LAT0
   if (pos('LAT0',s)>0)then begin
     for i:=1 to 4 do readln(nomf,s);
     delete(s,1,12);
     memo2.Lines.add(s+s1);
     nb_sol:=nb_sol+1;
   end;
 end;
 closefile(nomf);

//Copie du fichier
 assignfile(nomf,'lepage.lis');
 reset(nomf);
 while not(eof(nomf)) do begin
   readln(nomf,s);
   memo1.Lines.add(s);
 end;
 //memo1.itemIndex:=0;
 s:=memo1.lines[1];
 closefile(nomf);
 screen.cursor:=CRDefault;

end;

procedure Tflepage.sortie_gamma(Sender: TObject);
//---------------------------------------------
var
  ier  : integer;
begin
  relit_maille(ier);
end;

procedure Tflepage.sortie(Sender: TObject);
//----------------------------------------
begin
  close;
end;

procedure Tflepage.go_instru(Sender: TObject);
//------------------------------------------
begin
  finstru.visible:=true;
end;

procedure Tflepage.Load1Click(Sender: TObject);
//-------------------------------------------
var
  s          : string;
  nomf       : textfile;
  i          : integer;
begin
  if opendialog1.execute then begin
    s:=opendialog1.filename;
    if (s = '')then exit;
    assignfile(nomf,s);
    reset(nomf);
    for i:=1 to 6 do read(nomf,cel[i]);
    readln(nomf);
    closefile(nomf);
    str(cel[1]:8:4,s);
    edit10.Text:=s;
    str(cel[2]:8:4,s);
    edit11.Text:=s;
    str(cel[3]:8:4,s);
    edit12.Text:=s;
    str(cel[4]:8:3,s);
    edit13.Text:=s;
    str(cel[5]:8:3,s);
    edit14.Text:=s;
    str(cel[6]:8:3,s);
    edit15.Text:=s;
  end;
end;

procedure Tflepage.sauve_maille(Sender: TObject);
//----------------------------------------------
var
  s          : string;
  nomf       : textfile;
  i          : integer;
begin
  if savedialog1.execute then begin
    s:=savedialog1.filename;
    if (s = '')then exit;
    if (pos('.mai',s) = 0)then s:=s+'.mai';
    assignfile(nomf,s);
    rewrite(nomf);
    for i:=1 to 6 do write(nomf,cel[i]:10:4);
    writeln(nomf);
    closefile(nomf);
  end;
end;


end.
