unit mathhkl;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls, dialogs, math;

type
   {Donnes entre DLL}
   tab_real14                                   = array[1..14]of single;
   tab_int15                                    = array[1..15]of smallInt;

   {Donnes sortie DLL}
   tab_real100                                  = array[1..500] of real;
   tab_real1000                                 = array[1..1000]of single;
   tab_real10000                                = array[1..30000] of single;
   tab_int1000                                  = array[1..1000]of smallInt;
   tab_mess                                     = array[1..100] of smallInt;
   matrice3                                     = array[1..3,1..3] of real ;
   vecteur3                                     = array[1..3] of real;
   tab_reel                                     = array[1..11] of real;
   tab6_reel                                    = array[1..6] of real;
   tab_car                                      = array[1..128]of char;


type raie = record
  hr,kr,lr,ext                          : integer;
  dr,dtheta                             : real;
end;
//Solution Crysfire
type summary =record
  num,i20                               : integer;
  fom                                   : real;
  maille                                : array[1..6] of real;
  syst                                  : string[4];
  no_syst,no_truecell                   : integer;
  vv1,vol                               : real;
  liste                                 : string[73];
end;

var
   repertoire_origine,repertoire_donnees        : string;
   nom_fichier_ind                              : string;
   nom_fichier_raw                              : string;
   nom_fichier_dif                              : string;
   nom_fichier_sim                              : string;
   nom_fichier_sum                              : string;
   numero_fichier_dif, type_fichier_write       : integer;
   titre                                        : string;
   systeme,groupe_espace,formule                : string;
   bravais                                      : string[1];
   cel,celr,cel_depart                          : array[1..6] of real;
   r10,r01,r21,r12,r13,r31,r23,r32,r20,r02      : matrice3;

//Paramtres courants
   theta_min,theta_max,etendue                  : real;
   theta_min_depart,theta_max_depart            : real;
   lambda,lambda1,lambda2,ratio                 : real;
   anode                                        : string[2];
   nature_lambda                                : array[1..4] of string[6];
   nb_lambda                                    : integer;

//raies slectionnes pour CELREF par la procedure indexe
   nb_raies_obs                                 : integer;
   h_obs,k_obs,l_obs                            : array[1..1000] of SmallInt;
   dtheta_obs,dtheta_calc,dtheta_obs_cor        : array[1..1000] of single;

//Arguments DLL INDX
   tab                                          : tab_real14;
   itab                                         : tab_int15;
   tabmes                                       : tab_mess;
   nb_raies_indx,nb_raies_indx_eteint           : smallInt;
   raies_indx,raies_indx_eteint                 : array[1..10000] of raie;
   theta_min_indx,theta_max_indx                : real;
   lambda_indx                                  : real;

//raies du spectre RAW
   titre_raw                                    : string;
   x_theta,y_intensite                          : tab_real10000;
   nb_raies_raw, couleur_raw                    : integer;
   lambda_raw,lambda1_raw,lambda2_raw,ratio_raw : real;
   anode_raw                                    : string[2];
   theta_min_raw,theta_max_raw,pas_raw          : real;
   ymax_raw,ymin_raw                            : real;

//raies du spectre DIF
   titre_dif                                    : string;
   theta_dif,theta_dif_old,intensite_dif        : tab_real100;
   nb_raies_dif,couleur_dif                     : integer;
   anode_dif                                    : string[2];
   lambda_dif,lambda1_dif,lambda2_dif,ratio_dif : real;
   theta_min_dif,theta_max_dif,pas_dif,ymax_dif : real;

   zero_shift,tolerance                         : real;
   epsa,epsb,epsa2,epsb2                        : real;

   ymax,ymin,theta1,theta2                      : single;
   numero4,numero5                              : integer;
   flag_affinement,flag_pointe                  : boolean;
   cel_af                                       : array[1..6] of real;
   mode_shift                                   : integer;
   no_select_raie                               : integer;
   nb_sol_crysfire,nb_groupes                   : integer;

//Liste Crysfire
   crysum                                       : array[1..10000] of summary;
   crysum_truecell                              : array[1..5000] of summary;
   fommax,v1                                    : real;
   i20max,nb_raies_i20                          : integer;

//settings ortho
   r                                            : array[1..3,1..3] of integer;
   Oabc                                         : array[1..6,1..3,1..3] of integer;
   no_setting                                   : integer;
   det_mat                                      : real;

   no_cell_truecell                             : integer;

   raies_somme                                  : array[1..2000] of raie;
   nb_somme                                     : integer;
   provenance                                   : string;

const
  pir         = 57.295780;
  pir2        = 114.591559;
  
   procedure erreur(s:string);
   procedure verif(var s:string);
   procedure decode_warning(tableau:tab_mess; var chaine:string);
   procedure dec(s:string; var tableau:tab_reel; var no,ier:integer);
   procedure decode_triplet (var s:string; var i1,i2,i3:integer);
   procedure quel_systeme;
   procedure quel_systeme2(var maille:tab_reel);
   procedure setmat;
   procedure chaine_to_car(var s: string; var caracteres: tab_car; nb: integer);
   procedure teste_fichier_unix(s:string;  var ier:integer);
   //procedure convertit_fichier_sum(nom_fichier: string);
function  Det      (Mat:matrice3): real;
procedure matinv   (Mat : matrice3; var mati :matrice3; var ier:integer);
Procedure ident    (mat : matrice3; var mati :matrice3);
procedure trspo    (var mat : matrice3);
procedure trfo     (u1,u2,u3: real; var v1,v2,v3 : real; var r : matrice3);
procedure trfo2    (var u1,u2,u3 : real; var r : matrice3);
procedure trfo4    (var v,v1 : vecteur3; var r : matrice3);
procedure mat_mult (ma,mb : matrice3; var mc : matrice3);
procedure modif_attrib(var s : string);
procedure cree_ligne_crysfire(var s:string);
//procedure efface_fichier(var s : string);

implementation

procedure warn(s:string);{
-------------------------}
begin
//   beep;
   MessageDlg(s,mtWarning,[mbOK],0);
end;

procedure erreur(s:string);{
---------------------------}
var w:word;
begin
  w:= MessageDlg(s,mtError,[mbOK],0);
end;

{Guerrit les .0 0. et -.}
procedure verif(var s:string);{
------------------------------}
var
  n         :integer;
begin
  if (s = '')then begin
    s:='0';
    exit;
  end;
  while (pos(' .',s) > 0)do s[pos(' .',s)]:='0';
  while (pos('. ',s) > 0)do s[pos('. ',s)+1]:='0';
  while (pos('-.',s) > 0)do s[pos('-.',s)+1]:='0';
end;

procedure decode_triplet (var s:string; var i1,i2,i3:integer);
{-----------------------------------------------------------}
var
  i,ier      : integer;
  s1,ss      : string;

begin
   if (s = '')then begin
     i1:=0;
     i2:=0;
     i3:=0;
     exit;
   end;
  ss:=s;
  ss:=trimleft(ss);
  //l:=length(ss);
  i:=pos(' ',ss);
  s1:=copy(ss,1,i-1);
  val(s1,i1,ier);

  ss:=copy(ss,i+1,length(ss)-i);
  ss:=trimleft(ss);
  //l:=length(ss);
  i:=pos(' ',ss);
  s1:=copy(ss,1,i-1);
  val(s1,i2,ier);

  ss:=copy(ss,i+1,length(ss)-i);
  val(ss,i3,ier);

end;

procedure decode_warning(tableau:tab_mess; var chaine:string);{
--------------------------------------------------------------}
var
    i,l,k             : integer;
begin
  l:=tableau[1];
  setlength(chaine,l);
  for i:=1 to l do begin
    k:=tableau[i+1];
    chaine[i]:=chr(k);
  end;
end;

procedure quel_systeme;
//---------------------
var
  dif1,dif2,dif3,dif4,dif5,dif6          : real;
begin
 dif1:=abs(cel[1]-cel[2]);
 dif2:=abs(cel[2]-cel[3]);
 dif3:=abs(cel[3]-cel[1]);
 dif4:=abs(cel[4]-cel[5]);
 dif5:=abs(cel[5]-cel[6]);
 dif6:=abs(cel[6]-cel[4]);

//Cubique
 if (abs(cel[4]-90) < epsa) and (abs(cel[5]-90) < epsa)
                            and (abs(cel[6]-90) < epsa)then begin
   if (dif1 < epsb) and (dif2 < epsb) and (dif3 < epsb)then begin
     systeme:='CUBI';
     exit;
   end;

//Tetragonal
   if (dif1 < epsb) and (dif2 > epsb) then begin
     systeme:='TETR';
     exit;
   end;

//Orthorhombique
   if (dif1 > epsb) and (dif2 > epsb) then begin
     systeme:='ORTH';
     exit;
   end;

//Hexagonal
 end else if (dif1 < epsb)
         and (abs(cel[4]-90) < epsa) and (abs(cel[5]-90) < epsa)
         and (abs(cel[6]-120)< epsa)then begin
   systeme:='HEXA';
   exit;

//Rhomboedrique
 end else if (dif1 < epsb) and (dif2 < epsb) and (dif3 < epsb)
         and (dif4 < epsa) and (dif5 < epsa) and (dif6< epsa)
  then begin
   systeme:='RHOM';
   exit;
 end else if (abs(cel[4]-90) < epsa) and (abs(cel[5]-90) > epsa)
                                     and (abs(cel[6]-90) < epsa)then begin
//Monoclinique
   systeme:='MONO';
   exit;
   
 end else begin
//Triclinique
   systeme:='TRIC';
   exit;
 end;

end;
procedure mat_mult (ma,mb: matrice3; var mc : matrice3);{
--------------------------------------------------------}
var
  i,j,k :integer;
begin
  for k:=1 to 3 do begin
    for j:=1 to 3 do begin
      mc[j,k]:=0;
      for i:=1 to 3 do begin
        mc[j,k]:=mc[j,k]+ma[j,i]*mb[i,k];
      end;
    end;
  end;
end;

procedure setmat;
//--------------
var
      a,b,c                                : real;
      sa,sb,sc,sbe,sce,ca,cb,cc            : real;
      cae,cbe,cce                          : real;
      q,v                                  : real;
      i,j                                  : integer;
begin
      {assignFile(nomat,'matrices.txt');
      rewrite(nomat);}
      a:=cel[1];
      b:=cel[2];
      c:=cel[3];
      //alpha:=cel[4];
      //beta:=cel[5];
      //gamma:=cel[6];
      ca:=cos(cel[4]/57.2957);
      cb:=cos(cel[5]/57.2957);
      cc:=cos(cel[6]/57.2957);
{     writeln(nomat,'ca,cb,cc:',ca:12:6,cb:12:6,cc:12:6);}
      sa:=sin(cel[4]/57.2957);
      sb:=sin(cel[5]/57.2957);
      sc:=sin(cel[6]/57.2957);
{     writeln(nomat,'sa,sb,sc:',sa:12:6,sb:12:6,sc:12:6);}
      q:=1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc;
      v:=a*b*c*sqrt(q);
      celr[1]:=b*c*sa/v;
      celr[2]:=c*a*sb/v;
      celr[3]:=a*b*sc/v;
      cae:=(cb*cc-ca)/(sb*sc);
      cbe:=(cc*ca-cb)/(sc*sa);
      cce:=(ca*cb-cc)/(sa*sb);
      celr[4]:=arccos(cae);
      celr[4]:=celr[4]*57.2957;
      celr[5]:=arccos(cbe);
      sbe:=sin(celr[5]);
      celr[5]:=celr[5]*57.2957;
      celr[6]:=arccos(cce);
      sce:=sin(celr[6]);
      celr[6]:=celr[6]*57.2957;

{-----Orthonormalisation du rseau rciproque R21}
      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          r21[i,j]:=0;
          r10[i,j]:=0;
          r20[i,j]:=0;
        end;
      end;
      r21[1,1]:=celr[1];
      r21[1,2]:=celr[2]*cce;
      r21[1,3]:=celr[3]*cbe;
      r21[2,2]:=celr[2]*sce;
      r21[2,3]:=-celr[3]*sbe*ca;
      r21[3,3]:=1./cel[3];
      r10[1,1]:=a*a;
      r10[1,2]:=a*b*cc;
      r10[1,3]:=a*c*cb;
      r10[2,2]:=b*b;
      r10[2,3]:=c*b*ca;
      r10[3,3]:=c*c;
      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          r10[j,i]:=r10[i,j];
        end;
      end;
      mat_mult(r21,r10,r20);
  end;
  

//Extrait jusqu'a 10 rels d'une chaine s. no:nb de rels trouvs(==>tableau )
procedure dec(s:string; var tableau:tab_reel; var no,ier:integer);
//----------------------------------------------------------------
var
  s1                            : string;
  i,j,l                         : integer;
 no_erreur                      : array[1..11] of integer;

begin
  s:=trim(s);
  l:=length(s);
  no:=0;
  for i:=1 to l do begin
    if (s[i] = ',') then s[i]:=' ';
  end;

  while (l > 0) do begin
    j:=pos(' ',s);
    if (j = 0)then j:=l;
    no:=no+1;
    s1:=copy(s,1,j);
    s1:=trim(s1);
    no_erreur[no]:=0;
    val(s1,tableau[no],ier);
    if(ier <> 0)then  no_erreur[no]:=1;
    delete(s,1,j);
    s:=trim(s);
    l:=length(s);
    if (no = 11)then exit;
  end;
 end;

procedure chaine_to_car(var s: string; var caracteres: tab_car; nb: integer);
//--------------------------------------------------------------------------
var
  i,l          : integer;
begin
  for i:=1 to 128 do caracteres[i]:=' ';
  if (length(s) < nb) then l:=length(s) else l:=nb;
  for i:=1 to l do caracteres[i]:=s[i];
end;

procedure teste_fichier_unix(s:string;  var ier:integer);
//----------------------------------------------------------
var
  nomf                       : file;
  sortie                     : TextFile;
  sv,se                      : string;
  n,i,n13                    : integer;
  b,b0                       : byte;
begin
  ier:=0;

//Est-ce un fichier Unix?
  modif_attrib(s);
  assignfile(nomf,s);
  reset(nomf,1);

//Recherche de la squence RC(13)+LF(10)
 (* b0:=0;
  for i:=1 to 300 do begin
    blockread(nomf,b,1);
    if (b = 10)then break;
    b0:=b;
  end;
  closefile(nomf);
  if (b0 = 13)then begin
    ier:=0;
    exit;
  end;*)   //Ce n'est pas un fichier Unix

//ecriture dans le fichier dummy.tmp
  ier:=1;
  modif_attrib(s);
  AssignFile(nomf,s);
  reset(nomf,1);
  s:='dummy.tmp';
  if FileExists(s) then modif_attrib(s);
  AssignFile(sortie,'dummy.tmp');
  rewrite(sortie);
 (* sv:='';
  for i:=1 to 250 do sv:=sv+' ';
  s:=sv;
  n:=0;
  while not eof(nomf) do begin
    blockread(nomf,b,1);
    if (b = 13)then continue;
    if (b = 10)then begin
      se:=copy(s,1,n);
      writeln(sortie,se);
      n:=0;
      s:=sv;
      continue;
    end;
    n:=n+1;
    if (n > 250) then continue;
    s[n]:=chr(b);
  end;  *)
    s:='';
    while not(eof(nomf)) do begin
      blockread(nomf,b,1);
      if (b = 13)then continue;
      if (b = 10)then begin
        writeln(sortie,s);
        s:='';
        continue;
      end;
      s:=s+chr(b);
    end;

  closefile(nomf);
  closefile(sortie);
end;

procedure quel_systeme2(var maille:tab_reel);
//-------------------------------------------
var
  dif1,dif2,dif3,dif4,dif5,dif6,x          : real;
  i:integer;
  nomf:textfile;
begin
 dif1:=abs(maille[1]-maille[2]);
 dif2:=abs(maille[2]-maille[3]);
 dif3:=abs(maille[3]-maille[1]);
 dif4:=abs(maille[4]-maille[5]);
 dif5:=abs(maille[5]-maille[6]);
 dif6:=abs(maille[6]-maille[4]);
// alpha=beeta=gamma=90

//Cubique
 if (abs(maille[4]-90) < epsa) and (abs(maille[5]-90) < epsa) and
 (abs(maille[6]-90) < epsb)then begin
   if (dif1 < epsb) and (dif2 < epsb) and (dif3 < epsb)then begin
     systeme:='CUBI';
     exit;
   end;
//Tetragonal c<>b et a
   if (dif1 < epsb) and (dif2 > epsb) then begin
     systeme:='TETR';
     exit;
   end;
//Orthorhombique
   if (dif1 > epsb) and (dif2 > epsb) then begin
     systeme:='ORTH';
     if (dif3 < epsb)then begin
       systeme:='TETR';
       x:=maille[2];
       maille[2]:=maille[3];
       maille[3]:=x;
       exit;
     end;
   end;

//Hexagonal
 end else if (dif1 < epsb)
              and (abs(maille[4]-90) < epsa) and (abs(maille[5]-90) < epsa)
              and (abs(maille[6]-120)< epsa) then begin
   systeme:='HEXA';
   exit;
//Rhomboedrique
 end else if (dif1 < epsb) and (dif2 < epsb) and (dif3 < epsb)
         and (dif4 < epsa) and (dif4 < epsa) and (dif4 < epsa)
 then begin
   systeme:='RHOM';
   exit;
//Monoclinique
 end else if (abs(maille[4]-90) < epsa) and (abs(maille[5]-90) > epsa)
         and (abs(maille[6]-90) < epsa) then begin
   systeme:='MONO';
   exit;
 //Triclinique
 end else begin
   systeme:='TRIC';
   //assignfile(nomf,'espion.txt');
   //rewrite(nomf);
   //for i:=1 to 6 do write(nomf,maille[i]:8:4);
   //writeln(nomf,epsa:10:4,epsb:10:4);
   //writeln(nomf,dif1:10:5,dif2:10:5,dif3:10:5,dif4:10:5,dif5:10:5,dif6:10:5) ;
   //closefile(nomf);
   exit;
 end;

end;

function  Det      (Mat:matrice3): real;{
----------------------------------------}
begin
  det:=mat[1,1]*(mat[2,2]*mat[3,3]-mat[3,2]*mat[2,3])
      -mat[1,2]*(mat[2,1]*mat[3,3]-mat[3,1]*mat[2,3])
      +mat[1,3]*(mat[2,1]*mat[3,2]-mat[3,1]*mat[2,2]);
end;

{Inversion de matrice}
procedure matinv   (Mat : matrice3; var Mati : matrice3; var ier:integer);{
---------------------------------------------------------------------------}
var
  i,j      : integer;

begin
  ier:=0;
  mati[1,1]:=mat[2,2]*mat[3,3]-mat[2,3]*mat[3,2];
  mati[1,2]:=mat[1,3]*mat[3,2]-mat[1,2]*mat[3,3];
  mati[1,3]:=mat[1,2]*mat[2,3]-mat[1,3]*mat[2,2];

  mati[2,1]:=mat[2,3]*mat[3,1]-mat[2,1]*mat[3,3];
  mati[2,2]:=mat[1,1]*mat[3,3]-mat[1,3]*mat[3,1];
  mati[2,3]:=mat[1,3]*mat[2,1]-mat[1,1]*mat[2,3];

  mati[3,1]:=mat[2,1]*mat[3,2]-mat[2,2]*mat[3,1];
  mati[3,2]:=mat[1,2]*mat[3,1]-mat[1,1]*mat[3,2];
  mati[3,3]:=mat[1,1]*mat[2,2]-mat[1,2]*mat[2,1];

  det_mat:=det(Mat);
  if(abs(det_mat) < 1.0e-15)then begin
    ier:=1;
//    erreur('Matrice singulire');
    exit;
  end;
  For i:=1 to 3 do begin
    For j:= 1 to 3 do begin
      mati[i,j]:= mati[i,j]/det_mat;
    end;
  end;
end;

Procedure ident (mat : matrice3; var mati :matrice3);{
-----------------------------------------------------}
var i,j  :integer;
begin
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      mati[i,j]:=mat[i,j];
    end;
  end;
end;

procedure trspo(var mat : matrice3);{
------------------------------------}
var
  i,j  :integer;
  mati :matrice3;
begin
  ident(mat,mati);
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      mat[i,j]:=mati[j,i];
    end;
  end;
end;

procedure trfo (u1,u2,u3: real; var v1,v2,v3 : real; var r : matrice3);{
-----------------------------------------------------------------------}
begin
  v1:=u1*r[1,1]+u2*r[1,2]+u3*r[1,3];
  v2:=u1*r[2,1]+u2*r[2,2]+u3*r[2,3];
  v3:=u1*r[3,1]+u2*r[3,2]+u3*r[3,3];
end;

procedure trfo2(var u1,u2,u3 : real; var r : matrice3);{
-------------------------------------------------------}
var
  v1,v2,v3  : real;
begin
  v1:=u1*r[1,1]+u2*r[1,2]+u3*r[1,3];
  v2:=u1*r[2,1]+u2*r[2,2]+u3*r[2,3];
  v3:=u1*r[3,1]+u2*r[3,2]+u3*r[3,3];
  u1:=v1;
  u2:=v2;
  u3:=v3
end;

procedure trfo4(var v,v1 : vecteur3; var r : matrice3);{
-------------------------------------------------------}
begin
  v1[1]:=v[1]*r[1,1]+v[2]*r[1,2]+v[3]*r[1,3];
  v1[2]:=v[1]*r[2,1]+v[2]*r[2,2]+v[3]*r[2,3];
  v1[3]:=v[1]*r[3,1]+v[2]*r[3,2]+v[3]*r[3,3];
end;

procedure modif_attrib(var s:string);
//-------------------------------
var
  attributs   : word;
begin
  attributs:=FileGetAttr(s);
  attributs:=attributs and not faReadonly;
  FileSetAttr(s,attributs);
end;

procedure cree_ligne_crysfire(var s:string);
//-----------------------------------------
var
   maille                    : tab_reel;
   no,n,i,ier                  :integer;
   s1                        : string;
begin
  dec(s,maille,no,ier);
  s:='';
  i:=round(maille[2]);str(i:2,s1); s:=s+s1; //I/I20
  str(maille[3]:8:2,s1)           ;s:=s+s1; //FOM
  str(maille[11]:11:3,s1)         ;s:=s+s1; // V
  str(maille[4]:6:2,s1)           ;s:=s+s1; //V/V1
  for i:=1 to 39 do s:=s+' ';
  str(maille[5]:9:4,s1)           ;s:=s+s1; //a
  str(maille[6]:9:4,s1)           ;s:=s+s1; //b
  str(maille[7]:9:4,s1)           ;s:=s+s1; //c
  str(maille[8]:8:3,s1)           ;s:=s+s1; //alpha
  str(maille[9]:8:3,s1)           ;s:=s+s1; //beta
  str(maille[10]:8:3,s1)          ;s:=s+s1; //gamma
end;
end.
