unit mcrnl;

interface

uses
   SysUtils, forms, math,mathhkl;


procedure rafine(var vol_av,vol_ap,sig_vol: double; var ier:integer);

implementation

uses
 mathhkl_3;

var
  nomf                    : textfile;
  nb_cycles               : integer;
  nom_fichier             : string;
  ifin                    : integer;
  sigma_lambda            : real;

procedure calcul_sigma_vol(var sigma_vol  : double);
//--------------------------------------------------
var
  dvp                                          : array[1..8] of double;
  qv,aa,bb,cc,calf,cbet,cgam,salf,sbet,sgam    : double ;
  i,j                                          : integer;
 // nomf : textfile;
begin
  aa:=cel[1];
  bb:=cel[2];
  cc:=cel[3];
  calf:=cos(cel[4]/57.2957);
  cbet:=cos(cel[5]/57.2957);
  cgam:=cos(cel[6]/57.2957);
  salf:=sin(cel[4]/57.2957);
  sbet:=sin(cel[5]/57.2957);
  sgam:=sin(cel[6]/57.2957);
  qv:=sqrt(sqr(calf)+sqr(cbet)+sqr(cgam)-2*calf*cbet*cgam);
  dvp[1]:=bb*cc*qv;
  dvp[2]:=cc*aa*qv;
  dvp[3]:=aa*bb*qv;
  dvp[4]:=aa*bb*cc*salf*(cbet*cgam-calf)/qv;
  dvp[5]:=aa*bb*cc*sbet*(cgam*calf-cbet)/qv;
  dvp[6]:=aa*bb*cc*sgam*(calf*cbet-cgam)/qv;
  sigma_vol:=0;
  for i:=1 to 6 do sigma_vol:=sigma_vol+abs(dvp[i]*sig_dir[i]/57.2957);
end;

procedure calcul_sigma;
//---------------------
var
 da_dae,da_dbe,da_dce,da_dalphae,da_dbetae,da_dgamae                          : double;
 db_dae,db_dbe,db_dce,db_dalphae,db_dbetae,db_dgamae                          : double;
 dc_dae,dc_dbe,dc_dce,dc_dalphae,dc_dbetae,dc_dgamae                          : double;
 dalpha_dae,dalpha_dbe,dalpha_dce,dalpha_dalphae,dalpha_dbetae,dalpha_dgamae  : double;
 dbeta_dae,dbeta_dbe,dbeta_dce,dbeta_dalphae,dbeta_dbetae,dbeta_dgamae        : double;
 dgama_dae,dgama_dbe,dgama_dce,dgama_dalphae,dgama_dbetae,dgama_dgamae        : double;
 i,j                                                                       : integer;
 ae,be,ce,cae,cbe,cce,sae,sbe,sce,q,q2,q3                                  : double;
 sa,sb,sc,r                                                                  : double;
begin

//Calcul des sigma sur les paramtres rciproques
 r:=0;
 for i:=1 to nr do r:=r+sqr(th_obs[i]-th_calc[i]);
 r:=r/(nr-npaf);
 resid:=2*pir*sqrt(r);
 j:=0;
 for i:=1 to 8 do begin
   if (afi[i] = 0)then continue;
   j:=j+1;
   sig_rec[j]:=sqrt(qt[j,j]*r);
 end;

//calcul des sigmas sur les paramtres directs
 ae:=celr[1];
 be:=celr[2];
 ce:=celr[3];
 cae:=cos(celr[4]);cbe:=cos(celr[5]);cce:=cos(celr[6]);
 sae:=sin(celr[4]);sbe:=sin(celr[5]);sce:=sin(celr[6]);
 q2:=1-cae*cae-cbe*cbe-cce*cce+2*cae*cbe*cce; q:=sqrt(q2); q3:=q*q2;
 sa:=sin(cel[4]/pir);sb:=sin(cel[5]/pir);sc:=sin(cel[6]/pir);
 da_dae:=0; da_dbe:=0;  da_dce:=0;
 da_dalphae:=0; da_dbetae:=0; da_dgamae:=0;
 db_dae:=0; db_dbe:=0;  db_dce:=0;
 db_dalphae:=0; db_dbetae:=0; db_dgamae:=0;
 dc_dae:=0; dc_dbe:=0;  dc_dce:=0;
 dc_dalphae:=0; dc_dbetae:=0; dc_dgamae:=0;
 dalpha_dae:=0;dalpha_dbe:=0;dalpha_dce:=0;dalpha_dalphae:=0;dalpha_dbetae:=0;
 dalpha_dgamae:=0;dbeta_dae:=0;dbeta_dbe:=0;dbeta_dce:=0;dbeta_dalphae:=0;
 dbeta_dbetae:=0;dbeta_dgamae:=0;dgama_dae:=0;dgama_dbe:=0;dgama_dce:=0;
 dgama_dalphae:=0;dgama_dbetae:=0;dgama_dgamae:=0;

//a
 if (afi[1] > 0)then begin
   da_dae:=abs(sae/(ae*ae*q)); da_dbe:=0;  da_dce:=0;
   da_dalphae:=abs(cae/(ae*q)-sae*sae*(cae-cbe*cce)/(ae*q3));
   da_dbetae:=abs(sae*sbe*(cbe-cae*cce)/(ae*q3));
   da_dgamae:=abs(sae*sce*(cce-cae*cbe)/(ae*q3));
   sig_dir[1]:=da_dae*sig_rec[1]+da_dbe*sig_rec[2]+da_dce*sig_rec[3]+
             da_dalphae*sig_rec[4]+da_dbetae*sig_rec[5]+da_dgamae*sig_rec[6];
 end;
//b
 if (afi[2] > 0)then begin
   db_dae:=0; db_dbe:=abs(sbe/(be*be*q));  db_dce:=0;
   db_dalphae:=abs(sbe*sae*(cae-cbe*cce)/(be*q3));
   db_dbetae:=abs(cbe/(be*q)-sbe*sbe*(cbe-cae*cce)/(be*q3));
   db_dgamae:=abs(sbe*sce*(cce-cae*cbe)/(be*q3));
   sig_dir[2]:=db_dae*sig_rec[1]+db_dbe*sig_rec[2]+db_dce*sig_rec[3]+
             db_dalphae*sig_rec[4]+db_dbetae*sig_rec[5]+db_dgamae*sig_rec[6];
 end;
//c
 if (afi[3] > 0)then begin
   dc_dae:=0;  dc_dbe:=0; dc_dce:=abs(sce/(ce*ce*q));
   dc_dalphae:=abs(sce*sae*(cae-cbe*cce)/(ce*q3));
   dc_dbetae:=abs(sce*sbe*(cbe-cae*cce)/(ce*q3));
   dc_dgamae:=abs(cce/(ce*q)-sce*sce*(cce-cae*cbe)/(ce*q3));
   sig_dir[3]:=dc_dae*sig_rec[1]+dc_dbe*sig_rec[2]+dc_dce*sig_rec[3]+
             dc_dalphae*sig_rec[4]+dc_dbetae*sig_rec[5]+dc_dgamae*sig_rec[6];
 end;
//alpha
 if (afi[4] > 0)then begin
   dalpha_dae:=0;dalpha_dbe:=0;dalpha_dce:=0;
   dalpha_dalphae:=sae/(sbe*sce);
   dalpha_dalphae:=abs(dalpha_dalphae/sa);
   dalpha_dbetae:=-cce/sce-cbe*sce*(cbe*cce-cae)/sqr(sbe*sce);
   dalpha_dbetae:=abs(dalpha_dbetae/sa);
   dalpha_dgamae:=-cbe/sbe-cce*sce*(cbe*cce-cae)/sqr(sbe*sce);
   dalpha_dgamae:=abs(dalpha_dgamae/sa);
   sig_dir[4]:=dalpha_dae*sig_rec[1]+dalpha_dbe*sig_rec[2]+dalpha_dce*sig_rec[3]+
             dalpha_dalphae*sig_rec[4]+dalpha_dbetae*sig_rec[5]+dalpha_dgamae*sig_rec[6];
   sig_dir[4]:=pir*sig_dir[4];
 end;
//beta
 if (afi[5] > 0)then begin
   dbeta_dae:=0;dbeta_dbe:=0;dbeta_dce:=0;
   dbeta_dalphae:=-cce/sce-cae*sce*(cae*cce-cbe)/sqr(sae*sce);
   dbeta_dalphae:=abs(dbeta_dalphae/sb);
   dbeta_dbetae:=sbe/(sae*sce);
   dbeta_dbetae:=abs(dbeta_dbetae/sb);
   dbeta_dgamae:=-cae/sae-cce*sae*(cae*cce-cbe)/sqr(sae*sce);
   dbeta_dgamae:=abs(dbeta_dgamae/sb);
   sig_dir[5]:=dbeta_dae*sig_rec[1]+dbeta_dbe*sig_rec[2]+dbeta_dce*sig_rec[3]+
             dbeta_dalphae*sig_rec[4]+dbeta_dbetae*sig_rec[5]+dbeta_dgamae*sig_rec[6];
   sig_dir[5]:=pir*sig_dir[5];
 end;
//gamma
 if (afi[6] > 0)then begin
   dgama_dae:=0;dgama_dbe:=0;dgama_dce:=0;
   dgama_dalphae:=-cbe/sbe-cae*sbe*(cae*cbe-cce)/sqr(sae*sce);
   dgama_dalphae:=abs(dalpha_dbetae/sc);
   dgama_dbetae:=-cae/sae-cbe*sae*(cae*cbe-cce)/sqr(sae*sbe);
   dgama_dbetae:=abs(dgama_dbetae/sc);
   dgama_dgamae:=sce/(sae*sbe);
   dgama_dgamae:=abs(dgama_dgamae/sc);
   sig_dir[6]:=dgama_dae*sig_rec[1]+dgama_dbe*sig_rec[2]+dgama_dce*sig_rec[3]+
             dgama_dalphae*sig_rec[4]+dgama_dbetae*sig_rec[5]+dgama_dgamae*sig_rec[6];
   sig_dir[6]:=pir*sig_dir[6];
 end;

//Zero
  if (afi[7] > 0)then sig_dir[7]:=sig_rec[7];

//Longueur d'onde
   if (afi[8] > 0)then sig_dir[8]:=sig_rec[8];

end;

procedure contraintes;
//--------------------
begin
      If (systeme = 'CUBI')then begin
               celr[2]:=celr[1];
               celr[3]:=celr[1];
               celr[5]:=celr[4];
               celr[6]:=celr[4];
      end else if (systeme = 'RHOM')then begin
               celr[2]:=celr[1];
               celr[3]:=celr[1];
               celr[5]:=celr[4];
               celr[6]:=celr[4];
      end else if (systeme = 'HEXA')then begin
               celr[2]:=celr[1];
               celr[5]:=celr[4];
      end else if (systeme = 'TETR')then begin
               celr[2]:=celr[1];
               celr[5]:=celr[4];
      end;
end;

procedure calc_theta;  //(theta en radians)
//-------------------
var
  d,dd                    : double;
  i,j                     : integer;
   ae,be,ce,cae,cbe,cce   : double;
begin
    contraintes;
    ae:=celr[1]; be:=celr[2];ce:=celr[3];
    cae:=cos(celr[4]);cbe:=cos(celr[5]);cce:=cos(celr[6]);
    for i:=1 to nr do begin
      dd:=sqr(ae*h[i])+sqr(be*k[i])+sqr(ce*l[i])
          +2.*(h[i]*k[i]*ae*be*cce+k[i]*l[i]*be*ce*cae
          +l[i]*h[i]*ce*ae*cbe);
      if (dd < 0.0000001)then begin
        erreur('nb de cycles : '+inttostr(nb_cycles));
      end;
      d:=1/sqrt(dd);
      if (afi[7] = 1) or (afi[7] = 0) then th_calc[i]:=par[7]+arcsin(par[8]/d);
      if (afi[7] = 2)then th_calc[i]:=par[7]*cos(th_obs[i])+arcsin(par[8]/d);
    end;
end;

Procedure calc ;
//-------------
var
   i,j,ir,n               : integer;
   d,dd,rad,f,r,x,xk      : double;
   ae,be,ce,cae,cbe,cce   : double;
begin
    contraintes;
    ae:=celr[1]; be:=celr[2];ce:=celr[3];
    cae:=cos(celr[4]);cbe:=cos(celr[5]);cce:=cos(celr[6]);

//Matrice Qnpaf
    for i:=1 to nr do begin
      n:=0;
      dd:=sqr(ae*h[i])+sqr(be*k[i])+sqr(ce*l[i])
          +2*(h[i]*k[i]*ae*be*cce+k[i]*l[i]*be*ce*cae
          +l[i]*h[i]*ce*ae*cbe);
      d:=1/sqrt(dd);
      if (afi[7] = 1) or (afi[7] = 0) then th_calc[i]:=par[7]+arcsin(par[8]/d);
      if (afi[7] = 2) then th_calc[i]:=par[7]*cos(th_obs[i])+arcsin(par[8]/d);
      rad:=sqrt(1.-dd*par[8]*par[8]);  //sin(t):=lambda/2d;
      f:=par[8]*d/rad;
      if (afi[1] <> 0)then begin
        n:=n+1;
        qnpaf[i,n]:=f*h[i]*(h[i]*ae+k[i]*be*cce+l[i]*ce*cbe);
      end;
      if (afi[2] <> 0)then begin
        n:=n+1;
        qnpaf[i,n]:=f*k[i]*(k[i]*be+l[i]*ce*cae+h[i]*ae*cce);
      end;
      if (afi[3] <> 0)then begin
        n:=n+1;
        qnpaf[i,n]:=f*l[i]*(l[i]*ce+h[i]*ae*cbe+k[i]*be*cae);
      end;
      if (afi[4] <> 0)then begin
        n:=n+1;
        qnpaf[i,n]:=-f*k[i]*l[i]*be*ce*sin(celr[4]);
      end;
      if (afi[5] <> 0)then begin
        n:=n+1;
        qnpaf[i,n]:=-f*l[i]*h[i]*ce*ae*sin(celr[5]);
      end;
      if (afi[6] <> 0)then begin
        n:=n+1;
        qnpaf[i,n]:=-f*h[i]*k[i]*ae*be*sin(celr[6]);
      end;
      if (afi[7] = 1)then begin  //zero constant
        n:=n+1;
        qnpaf[i,n]:=1;
      end;
      if (afi[7] = 2)then begin  //zero(theta)
        n:=n+1;
        qnpaf[i,n]:=cos(th_obs[i]);
      end;
      if (afi[8] <> 0)then begin  //Lambda
        n:=n+1;
        qnpaf[i,n]:=1/(rad*d);
      end;
    end;

//calcul des seconds membres (sec_membre)
     for j:=1 to npaf do begin
       r:=0;
       for i:=1 to nr do r:=r+(th_obs[i]-th_calc[i])*qnpaf[i,j];
       sec_membre[j]:=r;
     end;

end;

procedure do_mcrnl(var ier : integer);
//------------------------------------
var
  i,j,iq,il,ii,im,nn                            : integer;
  xk,resid_av,r,x                               : double;
  b_dep,par_dep                                 : tab_reel8;
  celr_dep                                      : tab_reel6;
  residu                                        : array[1..100] of double;
  s,s1                                          : string;
  cov                                           : tab_mat;
begin
  //assignfile(nomf,'mouchard');
  //rewrite(nomf);

  nb_cycles:=0;
  s:='';

  for i:=1 to 6 do begin
    if (i < 4) then str(celr[i]:8:5,s1)else str(celr[i]*pir:8:2,s1);
    s:=s+s1;
  end;

  xk:=1;

  for ii:=1 to ifin do begin

//Sauvegarde des paramtres
     for i:=1 to npaf do b_dep[i]:=b[i];
     for i:=1 to 8 do par_dep[i]:=par[i];
     for i:=1 to 6 do celr_dep[i]:=celr[i];

     calc_theta;
     calc;
     nb_cycles:=nb_cycles+1;

    // writeln(nomf,'Cycle Nb ',ii);
    // Writeln(nomf,'Matrice Q des quations normales');
    // for i:=1 to nr do begin
    //   for j:=1 to npaf do write(nomf,qnpaf[i,j]:10:5);
    //   writeln(nomf);
    // end;
    // writeln(nomf);

//construction de la matrice QT:=q*qt
     for iq:=1 to npaf do begin
       for il:=iq to npaf do begin
         r:=0;
         for i:=1 to nr do r:=r+qnpaf[i,iq]*qnpaf[i,il];
         qt[iq,il]:=r;
         qt[il,iq]:=r;
       end;
     end;

    (* Writeln(nomf,'Matrice Q*Qt');
     for i:=1 to npaf do begin
       for j:=1 to npaf do write(nomf,qt[i,j]:10:5);
       writeln(nomf);
     end;
     writeln(nomf); *)

//Inversion de la matrice QT
     nn:=npaf;
     matinv(qt,nn,ier);
     if (ier = 1)then begin

       //writeln(nomf,'Matrice singulire');
       //closefile(nomf);

       erreur('Singular Matrix');
       exit;
     end;

    (* Writeln(nomf,'Matrice inverse de Q*Qt');
     for i:=1 to npaf do begin
       for j:=1 to npaf do write(nomf,qt[i,j]:10:5);
       writeln(nomf);
     end;
     writeln(nomf); *)

     for i:=1 to npaf do
     for j:=1 to npaf do
     cov[i,j]:=qt[i,j]/sqrt(qt[i,i]*qt[j,j]);

//Mai2003:test de la matrice de covariance
     for i:=1 to npaf do begin
       for j:=1 to npaf do begin
         //write(nomf,cov[i,j]:10:5);
         if (i <> j) and (abs(cov[i,j]) > 2)then begin
           if (npaf > 1) and (afi[7] > 0)then
             erreur('Refinement cannot converge, Refine zero shift alone')
           else erreur('Refinement cannot converge');
           //closefile(nomf);
           exit;
         end;
       end;
       //writeln(nomf);
     end;
     //writeln(nomf);

//Calcul des nouveaux paramtres

    (* writeln(nomf,'Nouveaux paramtres');
     writeln(nomf,' No      1         2          1-2');  *)

     for i:=1 to npaf do begin
         r:=0;
         for j:=1 to npaf do r:=r+qt[i,j]*sec_membre[j];
         b[i]:=b[i]+xk*r;
         x:=(b_dep[i]-b[i]);
         //writeln(nomf,i:4,b_dep[i]:10:6,b[i]:10:6,x:12:7);
     end;
     //if (ier = 1)then continue;
     //writeln(nomf);
     j:=0;
     ier:=0;
     for i:=1 to 8 do begin
       if (afi[i] = 0) then continue;
       j:=j+1;
       par[i]:=b[j];
     (*  if (par[i] < 0) and (i < 7)then begin
         erreur('Refinement cannot converge');
         //closefile(nomf);
         exit;
       end; *)
     end;
     for i:=1 to 6 do celr[i]:=par[i];
     contraintes;

//Calcul des nouveaux theta
     calc_theta;

//Calcul du rsidu. Converge? Continuer?
     r:=0;
     for i:=1 to nr do r:=r+sqr(th_obs[i]-th_calc[i]);
     r:=r/(nr-npaf);
     residu[ii]:=sqrt(r);
     resid:=residu[ii];
     if (ii > 1)then begin
        if (resid >= resid_av) then begin
//Retour aux paramtres prcdents;
           for i:=1 to npaf do b[i]:=b_dep[i];
           for i:=1 to 8 do par[i]:=par_dep[i];
           for i:=1 to 6 do celr[i]:=celr_dep[i];
           xk:=xk*0.7;
           continue;
        end;
        if ((resid_av-resid)/abs(resid_av) <= 0.00001) then begin
          resid_av:=resid;
          break;
        end;
     end;

     resid_av:=resid;

   end;
   j:=0;
   for i:=1 to 8 do begin
     if (afi[i] = 0)then continue;
     j:=j+1;
     sig_rec[i]:=qt[j,j]*resid;
   end;

   //closefile(nomf);
end;

procedure affine_lambda(var ier : integer);
//---------------------------------------
var
  par_old,afi_old               : tab_reel8;
  i,j                           : integer;
begin

//mise en reserve des cls
  for i:=1 to 7 do begin
     afi_old[i]:=afi[i];
     afi[i]:=0;
  end;
  afi[8]:=1;

//Inconnues (paramtres  affiner);
  npaf:=1;
  b[npaf]:=par[8];

//Affinement de lambda
  do_mcrnl(ier);

//Calcul du sigma
  calc_theta;
  calcul_sigma;
  sigma_lambda:=sig_dir[8];

//Retour aux cls de dpart
  for i:=1 to 7 do afi[i]:=afi_old[i];
  afi[8]:=0;
  npaf:=0;
  for i:=1 to 8 do begin
    if (afi[i] > 0)then begin
      npaf:=npaf+1;
      b[npaf]:=par[i];
    end;
  end;

end;

procedure rafine(var vol_av,vol_ap,sig_vol: double; var ier:integer);
//--------------------------------------------------------------------
const
     icle : array[1..3] of string =('A:=b:=C','A:=b  ','NO   ');
var
     i,j                                : integer;
     x,r,delta,som                      : double;
     isys                               : integer;
     s                                  : string;
     maille_i,maille_o                  : tab_reel6;
     nomo                               : TextFile;
begin
     sigma_lambda:=0;
     nom_fichier:='celref.inp';
     ifin:=30;
     for i:=1 to 8 do begin
       afi[i]:=0;
       par[i]:=0;
       sig_dir[i]:=0;
       sig_rec[i]:=0;
     end;

//Lecture du d'entre fichier celref.inp
     assignfile(nomf,nom_fichier);
     reset(nomf);
     readln(nomf,titre);
     readln(nomf,systeme);

//Paramtres d'entre (zero en 7 et lambda en 8)
     for i:=1 to 8 do begin
       readln(nomf,par[i],afi[i]);
       if (i < 7)then cel[i]:=par[i];
     end;
     par[7]:=par[7]/pir2;
     par[8]:=par[8]/2;

     nr:=0;
     while not(eof(nomf)) do begin
      nr:=nr+1;
      readln(nomf,h[nr],k[nr],l[nr],th_obs[nr]);
      th_obs[nr]:=th_obs[nr]/pir2;
      if (th_obs[nr] = 0) then begin
        nr:=nr-1;
        break;
      end;
     end;
     closefile(nomf);
     setmat;
     for i:=1 to 6 do par[i]:=celr[i];

//Inconnues (paramtres  affiner);
     npaf:=0;
     for i:=1 to 8 do begin
        if (afi[i] > 0)then begin
          npaf:=npaf+1;
          b[npaf]:=par[i];
        end;
     end;

//Ecriture des donnes dans le fichier Celref.out
     assignfile(nomo,'celref.out');
     rewrite(nomo);
     s:=DateTimeToStr(Now);
     writeln(nomo,'CELREF Version 3.  '+s);
     for i:=1 to 70 do write(nomo,'-');
     writeln(nomo);
     writeln(nomo);
     writeln(nomo,titre);
     writeln(nomo);
     writeln(nomo,'Initial values    : (Refinement keys on 2nd line)');
     writeln(nomo,'--------------    :');

     vol_av:=volume;
     writeln(nomo,'  Zero    Lambda      a       b       c      alpha  beta   gamma   volume');
     write(nomo,2*par[7]*pir:8:3,2*par[8]:8:5);
     for i:=1 to 3 do write(nomo,cel[i]:9:4);
     for i:=4 to 6 do write(nomo,cel[i]:7:2);
     writeln(nomo,volume:10:3);
     write(nomo,afi[7]:4:0);
     write(nomo,afi[8]:7:0,' ');
     for i:=1 to 3 do write(nomo,afi[i]:9:0);
     write(nomo,'  ');
     for i:=4 to 6 do write(nomo,afi[i]:7:0);
     writeln(nomo);

//Ecriture des theta observs et calculs avant affinement
     calc_theta;
     writeln(nomo);
     writeln(nomo,'    H    K    L    2Th(obs) 2Th_obs-shift 2Th(Calc)    diff.');
     writeln(nomo);
     for i:=1 to nr do begin
       if (afi[7] <=0)then delta:=par[7] else
       delta:=par[7]*cos(th_obs[i]);
       writeln(nomo,h[i]:5,k[i]:5,l[i]:5,pir2*th_obs[i]:11:4,
       (th_obs[i]-delta)*pir2:13:4,pir2*(th_calc[i]-delta):11:4,pir2*(Th_obs[i]-th_calc[i]):11:4);
     end;

     writeln(nomo);
     r:=0;
     for i:=1 to nr do r:=r+sqr(pir2*(th_obs[i]-th_calc[i]));
     resid:=r/(nr-npaf);
     som:=r/nr;
     resid:=sqrt(resid);
     som:=sqrt(som);
     writeln(nomo,'Sqrt(Sum(2Th O-C)**2)/(Nref-Npar)) : ',resid:6:4);
     writeln(nomo,'Sqrt(Sum(2Th O-C)**2)/Nref       ) : ',som:6:4);

//AFfinement
     if (afi[8] = 1)then begin
       affine_lambda(ier);
       if (ier > 0)then begin
         closefile(nomo);
         exit;
       end;
     end;
     do_mcrnl(ier);
     if (ier > 0)then begin
       closefile(nomo);
       exit;
     end;
     contraintes;

     for i:=1 to 6 do maille_i[i]:=celr[i];
     reel_recip(maille_i,maille_o);
     for i:=1 to 3 do cel[i]:=maille_o[i];
     for i:=4 to 6 do cel[i]:=maille_o[i]*pir;

//Calcul des sigma sur les paramtres directs
     calcul_sigma;

//Ecriture des rsultats
     writeln(nomo);

     if (sig_dir[8] > 0)then begin
       writeln(nomo);
       writeln(nomo,'Warning');
       writeln(nomo,'-------');
       writeln(nomo);
       writeln(nomo,
       'Refining both the wavelength and the cell dimensions at the same time');
       writeln(nomo,
       'is dangerous because these parameters are strongly correlated.');
       writeln(nomo);
       writeln(nomo,
       'It is advisable to refine the wavelength only with a well known sample');
       writeln(nomo);
     end;

     writeln(nomo,'Final values      : (Standard errors on 2nd line)');
     writeln(nomo,'------------');
     writeln(nomo,'  Zero    Lambda      a       b       c      alpha  beta   gamma   volume');
     write(nomo,pir2*par[7]:8:3,2*par[8]:8:5);
     for i:=1 to 3 do write(nomo,cel[i]:9:4);
     for i:=4 to 6 do write(nomo,cel[i]:7:2);
     writeln(nomo,volume:10:3);
     write(nomo,pir2*sig_dir[7]:8:4);

//Modif 12 mai 2003
     calcul_sigma_vol(sigma_vol);
     vol_ap:=volume;
     sig_vol:=sigma_vol;
     if (sigma_lambda = 0)then write(nomo,sig_dir[8]:8:5)else write(nomo,sigma_lambda:8:5);
     for i:=1 to 3 do write(nomo,sig_dir[i]:9:4);
     write(nomo,' ');
     for i:=4 to 6 do write(nomo,sig_dir[i]:7:3);
     writeln(nomo,sigma_vol:9:3);
     writeln(nomo);
     writeln(nomo);

     writeln(nomo,'    H    K    L    2Th(obs) 2Th_obs-shift 2Th(Calc)    diff.');
     writeln(nomo);
     som:=0;
     for i:=1 to nr do begin
       if (afi[7] <=0)then delta:=par[7] else
       delta:=par[7]*cos(th_obs[i]);
       writeln(nomo,h[i]:5,k[i]:5,l[i]:5,pir2*th_obs[i]:11:4,
       (th_obs[i]-delta)*pir2:13:4,pir2*(th_calc[i]-delta):11:4,pir2*(Th_obs[i]-th_calc[i]):11:4);
       som:=som+sqr(pir2*(Th_obs[i]-th_calc[i]));
     end;
     som:=som/nr;
     som:=sqrt(som);
     writeln(nomo);
     writeln(nomo,'Sqrt(Sum(2Th O-C)**2)/(Nref-Npar)) : ',resid:6:4);
     writeln(nomo,'Sqrt(Sum(2Th O-C)**2)/Nref       ) : ',som:6:4);
     mess:='fin normale';
     closefile(nomo);
end;


end.
