unit truecell;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ComCtrls, ExtCtrls, StdCtrls, math, checklst, ColorBtns;

type
  Tftruecell = class(TForm)
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    ListBox2: TListBox;
    ListBox4: TListBox;
    ListBox6: TListBox;
    ProgressBar1: TProgressBar;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit9: TEdit;
    Edit11: TEdit;
    Label5: TLabel;
    Panel4: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Label15: TLabel;
    Panel5: TPanel;
    ListBox1: TListBox;
    Edit10: TEdit;
    CheckListBox1: TCheckListBox;
    RadioGroup1: TRadioGroup;
    SpeedButton1: TSpeedButton;
    BitBtn7: TBitBtn;
    Color95Button2: TColor95Button;
    Color95Button4: TColor95Button;
    Color95Button1: TColor95Button;
    BitBtn10: TBitBtn;
    BitBtn1: TBitBtn;
    BitBtn13: TBitBtn;
    procedure sortie(Sender: TObject);
    procedure ed_print(Sender: TObject);
    procedure Initialise(Sender: TObject);
    procedure run(Sender: TObject);
   // procedure click_solution_found(Sender: TObject);
    procedure cherche_best_sol(Sender: TObject);
    procedure on_click_lischeckbox(Sender: TObject);
    procedure onexitcheck(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure BitBtn10Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure calcule_densite(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ftruecell: Tftruecell;

implementation

{$R *.DFM}
uses
  unit1,mathhkl, supple, supercell, unit70;
type
  vecteur = record
  u,v,w       : integer;
  d,x,y,z     : real;
end;
var
  vect                                  : array[1..3000] of vecteur;
  nb_vecteurs                           : integer;
  psys                                  : string[4];
  no_syst,no_psys,no_case               : integer;
  nom_fichier                           : string;

procedure Tftruecell.sortie(Sender: TObject);
//---------------------------------------
begin
  color95button1.visible:=false;
  form1.Onclicklistbox4(sender);
  close;
end;

procedure Tftruecell.ed_print(Sender: TObject);
//---------------------------------------
var
    CmdFile      : Pchar;
    iwin,i       : integer;
    nomf         : TextFile;
begin
  if (nb_sol = 0)then exit;
  assignFile(nomf,'truecell.tmp');
  rewrite(nomf);
  writeln(nomf,'Initial cell');
  writeln(nomf,listbox2.items[0]);
  writeln(nomf,listbox2.items[1]);

  writeln(nomf);
  writeln(nomf,'Found cell(s)');
  writeln(nomf,listbox6.items[0]);
  for i:=1 to nb_sol-1 do writeln(nomf,listbox4.items[i-1]);
  CloseFile(nomf);
  CmdFile:='write.exe truecell.tmp';
  iwin:=WinExec(CmdFile,5);

end;

procedure Tftruecell.Initialise(Sender: TObject);
//------------------------------------------
var
   i               : integer;
begin
  listbox1.clear;
  listbox2.clear;
  checkListBox1.state[0]:=cbChecked;
  for i:=1 to 6 do checkListBox1.state[i]:=cbUnChecked;
  for i:=0 to nb_sol_crysfire do
  listbox1.Items.Add(form1.listbox4.Items[i]);
  listbox1.itemIndex:=1;
end;

Procedure verifie_sum(s:string; var n:integer);
//---------------------------------------------
var
  ier,no,i,j                     : integer;
  maille,maille_crys             : tab_reel;
  s1                             : string;
  vol,vol_crys                   : real;
begin
//donne le numero de solution de crysfire?
  delete(s,1,4);
  s:=copy(s,1,49);
  dec(s,maille,no,ier);
  vol:=maille[7];
  n:=0;
  for i:=1 to nb_sol_crysfire do begin
    s1:=ftruecell.listbox1.items[i];
    dec(s1,maille_crys,no,ier);
    vol_crys:=maille_crys[11];
    if (abs(vol-vol_crys) > 10)then continue;
    ier:=0;
    for j:=1 to 3 do begin
      if (abs(maille[j]-maille_crys[j+4]) > epsb2)then begin
        ier:=1;
        break;
      end;
    end;
    if(ier = 1)then continue;
    for j:=4 to 6 do begin
      if (abs(maille[j]-maille_crys[j+4]) > epsa2)then begin
        ier:=1;
        break;
      end;
    end;
    if(ier = 1)then continue else begin
      n:=i;
      exit;
    end;
  end;
end;

procedure search_syst(var a,b,c,alpha,beta,gamma:real);
//----------------------------------------------------
var
  dif1,dif2,dif3          : real;
begin
 psys:='';
 no_psys:=7;
 dif1:=abs(a-b);
 dif2:=abs(b-c);
 dif3:=abs(c-a);
//Cubique, quadratique, orthorhombique
 if (abs(alpha-90) < epsa) and (abs(beta-90) < epsa) and (abs(gamma-90) < epsa)then begin
   if (dif1 < epsb) and (dif2 < epsb) and (dif3 < epsb) then begin
     psys:='CUBI';
     no_psys:=1;
     exit;
   end;
   if (dif1 < epsb) and (dif2 > epsb) then begin
     psys:='TETR';
     no_psys:=2;
     exit;
   end;
   if (dif1 > epsb) and (dif2 > epsb) then begin
     psys:='ORTH';
     no_psys:=3;
     exit;
   end;
 end;
//Hexagonal
 if (dif1        < epsb)  and
 (abs(alpha-90)  < epsa)  and
 (abs(beta-90)   < epsa)  and
 (abs(gamma-120) < epsa)  then begin
   psys:='HEXA';
   no_psys:=4;
   exit;
 end;
//Rhomboedrique
 if (dif1 < epsb)       and (dif2 < epsb)         and (dif3 < epsb)   and
 (abs(alpha-beta) < epsa) and  (abs(alpha-gamma) < epsa) and (abs(gamma-beta) < epsa)
 then begin
   psys:='RHOM';
   no_psys:=5;
   exit;
 end;
//Monoclinique
 if (abs(alpha-90) < epsa) and (abs(gamma-90)< epsa) and (abs(beta-90)> epsa)then begin
   psys:='MONO';
   no_psys:=6;
   exit;
 end;
end;

procedure compose_ligne(var s: string);
//-------------------------------------
var
  s1                 : string;
  ier,no,i           : integer;
  vv1,vol            : real;
  tab                : tab_reel;
begin
  s:=trim(s);
  s1:=copy(s,5,57);
  dec(s1,tab,no,ier);
  if (ier > 0)then begin
     erreur('Decode error');
     exit;
  end;
  vv1:=tab[8];
  vol:=tab[7];

  s:='   0';
  str(i20:3,s1);
  s:=s+s1;
  str(fom_sol:8:2,s1);
  s:=s+s1;
  str(vv1:6:2,s1);
  s:=s+s1+' ';
  for i:=1 to 3 do begin
    str(tab[i]:7:3,s1);
    s:=s+s1;
  end;
  for i:=4 to 6 do begin
    str(tab[i]:7:2,s1);
    s:=s+s1;
  end;
  if (vol < 10000)then str(vol:9:1,s1)
  else if (vol >=10000) then str(vol:9:0,s1);
  s:=s+s1;
end;

procedure Tftruecell.run(Sender: TObject);
//------------------------------------
var
   wo                                   : word;
   a,b,c,alpha,beta,gamma               : real;
   i,j,k,l,ier,no,u_max,no_psys_lim,cas : integer;
   s,s1,systeme_l                       : string;
   p,ang,ca,cb,cc,q,v,v2,vol,rap,arg    : real;
   no_boucle,no_total                   : real;
   im,jm,km,i1,j1,n,nb_sum              : integer;
   w                                    : word;
   maille,maille2                       : tab_reel;
   chaine                               : array[1..500] of string;
   indic                                : array[1..500] of integer;
   mat,mu,phi,phi2,rphi,mum                 : matrice3;
   mat_h                                : array[1..6,1..3,1..3] of real;
   aaa,bbb,ccc,pa,pb,pc,palpha,pbeta,pgamma : real;
   nomf                                     : textfile;
   label 1;
const
   am1:array[1..9] of real= (1,0,0,-0.5,0.5,0,0,0,1);
   am2:array[1..9] of real= (0.5,-0.5,0,0,1,0,0,0,1);
   am3:array[1..9] of real= (0,0,1,0.5,0,-0.5,0,1,0);  //3
   am4:array[1..9] of real= (1,0,0,-0.5,0,0.5,0,-1,0); //4
   am5:array[1..9] of real= (0,0,1,0,0.5,-0.5,-1,0,0); //5
   am6:array[1..9] of real= (0,1,0,0,-0.5,0.5,1,0,0); //6
begin
  with fsupple do begin
    listbox4.clear;
    listbox2.clear;
    color95button1.visible:=false;
    panel2.visible:=false;
  end;

  listbox4.clear;
  no_cell_truecell:=listbox1.itemindex;   //numero de ligne et non numero de sol!!!!!
  panel2.visible:=true;
  k:=0;
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      k:=k+1;
      mat_h[1,i,j]:=am1[k];
      mat_h[2,i,j]:=am2[k];
      mat_h[3,i,j]:=am3[k];
      mat_h[4,i,j]:=am4[k];
      mat_h[5,i,j]:=am5[k];
      mat_h[6,i,j]:=am6[k];
    end;
  end;

//Acquisition valeurs des tolrances
  s:=edit1.Text;
  val(s,epsb,ier);
  if (ier > 0)then begin
    erreur('Error on Parameter tolerance');
    edit1.setfocus;
    exit;
  end;
  s:=edit2.Text;
  val(s,epsa,ier);
  if (ier > 0)then begin
    erreur('Error on angular tolerance');
    edit1.setfocus;
    exit;
  end;

//Indice_max
  u_max:=strtoint(edit9.text);
  //u_max:=2*u_max;

//V/v0 max
  s:=edit11.Text;
  val(s,rap,ier);
  if (ier > 0)then begin
    erreur('Error on V/Vo');
    edit1.setfocus;
    exit;
  end;

//Acquisition valeurs des tolrances pour comparaison
  s:=edit3.Text;
  val(s,epsb2,ier);
  if (ier > 0)then begin
    erreur('Error on Parameter tolerance');
    edit1.setfocus;
    exit;
  end;
  s:=edit4.Text;
  val(s,epsa2,ier);
  if (ier > 0)then begin
    erreur('Error on angular tolerance');
    edit1.setfocus;
    exit;
  end;

//Raze listboxes
  listbox2.clear;
  listbox6.clear;

//lecture de la maille
    if (listbox1.itemIndex < 1)then begin
      erreur('Select first a Crysfire solution!');
      exit;
    end;
    s:=listbox1.items[listbox1.itemIndex];
    dec(s,maille,no,ier);
    fom_sol:=maille[3];
    for i:=1 to 6 do begin
      cel[i]:=maille[i+4];
      cel_depart[i]:=maille[i+4];
    end;

    quel_systeme;
    no_syst:=7;
    if (systeme = 'CUBI')then no_syst:=1;
    if (systeme = 'TETR')then no_syst:=2;
    if (systeme = 'ORTH')then no_syst:=3;
    if (systeme = 'HEXA')then no_syst:=4;
    if (systeme = 'RHOM')then no_syst:=5;
    if (systeme = 'MONO')then no_syst:=6;
    case no_syst of
      1: Systeme_l:='Cubic';
      2: Systeme_l:='Tetragonal';
      3: Systeme_l:='Orthorhombic';
      4: Systeme_l:='Hexagonal';
      5: Systeme_l:='Rhomboedral';
      6: systeme_l:='Monoclinic';
    end;

//Systeme
  no_psys_lim:=no_syst;

//Selection absurde (par ex. si la solutio de dpart est cubique, on ne peut demander
//une solution quadratique)
  if (checklistbox1.state[0] = cbunchecked) and (no_psys <> 7) then begin
    j:=0;
    ier:=0;
    for i:= 1 to 6 do begin
      if (checklistbox1.state[i] = cbunchecked) then continue;
      case no_syst of
        1: if (i > 1) then ier:=1;
        2: if (i = 3) or (i > 5) then ier:=1;
        3: if (i > 5) then ier:=1;
        4: if (i = 3) or (i > 5) then ier:=1;
        5: if (i = 4) or (i > 5) then ier:=1;
        6: if (i > 6) then ier:=1;
      end;
      if (ier = 1)then begin
        erreur('From '+systeme_l+' cell, Truecell cannot search for a '+ checklistbox1.items[i]+' cell');
        screen.cursor:=crdefault;
        exit;
      end;
    end;

      (*if (checklistbox1.state[i] = cbchecked)then begin
        if (no_syst = 3) and (i = 4) then continue;  //(O => H)
        if (no_syst = 3) and (i = 5) then continue;  //(O => R)
        if (no_syst = 4) and (i = 5) then continue;  //(H => R)
        j:=i;
      end;
    end;
    if (j > 0)then begin
      beep;
      showmessage
      ('From '+systeme_l+' cell, Truecell cannot search for a '+ checklistbox1.items[j]+' cell');
      screen.cursor:=crdefault;
      exit;
    end; *)

  end;

  s:='Syst.   a      b      c    alpha  beta   gamma     V ';
  listbox2.items.add(s);
  s:='Syst.   A      B      C    Alpha  Beta   Gamma    V     V/V1'+
  '                  Transformation Matrix                 Nb';
  listbox6.items.add(s);
  s:='Syst.   A      B      C    Alpha  Beta   Gamma    V     V/V1        Nb';

//Ecriture de la solution selectionne dans listbox4 de fsupple
  ca:=cos(cel[4]/57.2957);
  cb:=cos(cel[5]/57.2957);
  cc:=cos(cel[6]/57.2957);
  q:=1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc;
  vol:=cel[1]*cel[2]*cel[3]*sqrt(q);
  s:=systeme;
  str(cel[1]:7:3,s1);
  s:=s+s1;
  str(cel[2]:7:3,s1);
  s:=s+s1;
  str(cel[3]:7:3,s1);
  s:=s+s1;
  str(cel[4]:7:2,s1);
  s:=s+s1;
  str(cel[5]:7:2,s1);
  s:=s+s1;
  str(cel[6]:7:2,s1);
  s:=s+s1;
  if (vol < 10000)then str(vol:9:1,s1)
  else if (vol >=10000) then str(vol:9:0,s1);
  s:=s+s1;
  s1:=copy(listbox1.Items[listbox1.itemindex],16,4);
  s:=s+s1+'    *';
  fsupple.ListBox4.Items.add(s);
  fsupple.caption:='Best solution for Trucell';
  fsupple.Label2.caption:='Cells found by Truecell (the first line = starting cell)';
//Ecriture dans listbox2
  listbox6.refresh;
  s:=systeme;
  str(cel[1]:7:3,s1);
  s:=s+s1;
  str(cel[2]:7:3,s1);
  s:=s+s1;
  str(cel[3]:7:3,s1);
  s:=s+s1;
  str(cel[4]:7:2,s1);
  s:=s+s1;
  str(cel[5]:7:2,s1);
  s:=s+s1;
  str(cel[6]:7:2,s1);
  s:=s+s1;
  if (vol < 10000)then str(vol:9:1,s1)
  else if (vol >=10000) then str(vol:9:0,s1);

  s:=s+s1;
  listbox2.items.add(s);
  listbox2.refresh;
  panel2.refresh;

  screen.cursor:=crhourglass;
  nb_vecteurs:=0;
  setmat;
  for i:=u_max downto -u_max do begin
    for j:=u_max downto -u_max do begin
      for k:= u_max downto 0 do begin
        if (i = 0)and (j = 0) and (k = 0) then continue;
        ier:=0;
        if (nb_vecteurs > 0)then begin
          for l:=1 to nb_vecteurs do begin
            with vect[l] do begin
              if (i+u = 0) and  (j+v = 0) and (k+w = 0)then begin
                ier:=1;
                break;
              end;
            end;
          end;
        end;
        if (ier = 1)then continue;
        nb_vecteurs:=nb_vecteurs+1;
        with vect[nb_vecteurs] do begin
          u:=i;
          v:=j;
          w:=k;
          x:=i*r20[1,1]+j*r20[1,2]+k*r20[1,3];
          y:=i*r20[2,1]+j*r20[2,2]+k*r20[2,3];
          z:=i*r20[3,1]+j*r20[3,2]+k*r20[3,3];
          (*
          x:=0.5*x;
          y:=0.5*y;
          z:=0.5*z;
           *)
          d:=sqrt(x*x+y*y+z*z);
        end;
      end;
    end;
  end;

//mailles
  nb_sol:=1;   //(solution de dpart de Truecell)
  no_boucle:=0;
  no_total:=nb_vecteurs*nb_vecteurs*nb_vecteurs/200;
  for i:=1 to nb_vecteurs-1 do begin
    im:=abs(vect[i].u mod 2)+abs(vect[i].v mod 2)+abs(vect[i].w mod 2);
    with vect[i] do begin
      mu[1,1]:=u;
      mu[1,2]:=v;
      mu[1,3]:=w;
      a:=d;
    end;

    for j:=i+1 to nb_vecteurs do begin
      with vect[j] do begin
        mu[2,1]:=u;
        mu[2,2]:=v;
        mu[2,3]:=w;
        b:=d;
      end;
      jm:=abs(vect[j].u mod 2)+abs(vect[j].v mod 2)+abs(vect[j].w mod 2);
      p:=vect[i].x*vect[j].x+vect[i].y*vect[j].y+vect[i].z*vect[j].z;
      cc:=p/(vect[i].d*vect[j].d);

//Click sur bouton Abort
      application.processmessages;
      if speedbutton1.Down then begin
          beep;
          wo:=messageDlg(' Do you want to abort the search?',
          mtConfirmation,mbYesNoCancel,0);
          if (wo= mryes)  then begin
             listbox4.items.add('Stopped by the user');
             screen.cursor:=crdefault;
             speedbutton1.down:=false;
             speedbutton1.refresh;
             color95button1.visible:=false;
             exit;
          end else begin
            speedbutton1.down:=false;
          end;
      end;

      for k:=1 to nb_vecteurs do begin
         no_boucle:=no_boucle+1;
         progressbar1.position:=round(no_boucle/no_total);

        if (k <= i) or (k <= j)then continue;
        km:=abs(vect[k].u mod 2)+abs(vect[k].v mod 2)+abs(vect[k].w mod 2);
        if (im = 0) and (jm = 0) and (km = 0)then continue;
        with vect[k] do begin
          mu[3,1]:=u;
          mu[3,2]:=v;
          mu[3,3]:=w;
          c:=d;
        end;

//Tridre direct?
        v2:=det(mu);
        if (abs(v2) < 0.0001)then continue;

        p:=vect[i].x*vect[k].x+vect[i].y*vect[k].y+vect[i].z*vect[k].z;
        cb:=p/(vect[i].d*vect[k].d);
        p:=vect[j].x*vect[k].x+vect[j].y*vect[k].y+vect[j].z*vect[k].z;
        ca:=p/(vect[j].d*vect[k].d);
        if (abs(ca) >= 1) or( abs(cb) >= 1) or (abs(cc) >= 1) then continue;
        alpha:=57.2957*arccos(ca);
        beta:=57.2957*arccos(cb);
        gamma:=57.2957*arccos(cc);

//Volume de la maille multiple
        q:=1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc;
        v2:=a*b*c*sqrt(q);
        pa:=a;pb:=b;pc:=c;
        palpha:=alpha;pbeta:=beta;pgamma:=gamma;

//systme de la maille multiple
        search_syst(pa,pb,pc,palpha,pbeta,pgamma);
        if (no_psys = 7)then continue;
        //if (no_psys >= no_psys_lim) and (no_psys_lim <> 3) then continue;

//la maille multiple est-elle ortho_hexagonal?
        ident(mu,mat);
        if (psys = 'ORTH') and (systeme = 'HEXA')then continue;
        if (psys ='ORTH') then begin
          cas:=0;
          if (abs(pa/pb-sqrt(3)) < 0.005)then cas:=2;
          if (abs(pb/pa-sqrt(3)) < 0.005)then cas:=1;
          if (abs(pa/pc-sqrt(3)) < 0.005)then cas:=3;
          if (abs(pc/pa-sqrt(3)) < 0.005)then cas:=4;
          if (abs(pb/pc-sqrt(3)) < 0.005)then cas:=5;
          if (abs(pc/pb-sqrt(3)) < 0.005)then cas:=6;
          if (cas > 0)then begin
            psys:='HEXA';
            no_psys:=4;
            for i1:=1 to 3 do
            for j1:=1 to 3 do
            mat[i1,j1]:=mat_h[cas,i1,j1];
            mat_mult(mat,mu,phi);
            ident(phi,mat);
            trspo(phi);
            mat_mult(r20,phi,rphi);
            pa:=sqrt(sqr(rphi[1,1])+sqr(rphi[2,1])+sqr(rphi[3,1]));
            pb:=sqrt(sqr(rphi[1,2])+sqr(rphi[2,2])+sqr(rphi[3,2]));
            pc:=sqrt(sqr(rphi[1,3])+sqr(rphi[2,3])+sqr(rphi[3,3]));
            arg:=(rphi[1,1]*rphi[1,2]+rphi[2,1]*rphi[2,2]+rphi[3,1]*rphi[3,2])/(pa*pb);
            if (abs(arg) > 1)then continue;
            pgamma:=57.2957*arccos(arg);
            arg:=(rphi[1,2]*rphi[1,3]+rphi[2,2]*rphi[2,3]+rphi[3,2]*rphi[3,3])/(pb*pc);
            if (abs(arg) > 1)then continue;
            palpha:=57.2957*arccos(arg);
            arg:=(rphi[1,3]*rphi[1,1]+rphi[2,3]*rphi[2,1]+rphi[3,3]*rphi[3,1])/(pc*pa);
            if (abs(arg) > 1)then continue;
            pbeta:=57.2957*arccos(arg);
            v2:=pa*pb*pc*sqrt(3)/2;
          end;
        end;

        if (v2/vol > rap) then continue;

//Exceptions
        if (no_psys >= no_psys_lim)then begin
          if (systeme = 'ORTH') and (psys = 'HEXA')then  goto 1;
          if (systeme = 'ORTH') and (psys = 'RHOM')then  goto 1;
          if (systeme = 'HEXA') and (psys = 'RHOM')then  goto 1;
        end;
1:      if (checklistbox1.state[0] = cbUnChecked)then begin
          if (CheckListBox1.state[no_psys] = cbUnChecked)then continue;
        end;

//Ecriture de la maille et volume
          s:=psys;
          str(pa:7:3,s1);
          s:=s+s1;
          str(pb:7:3,s1);
          s:=s+s1;
          str(pc:7:3,s1);
          s:=s+s1;
          str(palpha:7:2,s1);
          s:=s+s1;
          str(pbeta:7:2,s1);
          s:=s+s1;
          str(pgamma:7:2,s1);
          s:=s+s1;
          if (v2 < 10000)then str(v2:8:1,s1) else str(v2:8:0,s1);
          s:=s+s1;
          str(v2/vol:6:2,s1);
          s:=s+s1;
//Ecriture de la matrice MU
          s:=s+'  ';
          for i1:=1 to 3 do begin
            s:=s+'(';
            for j1:=1 to 3 do begin
              str(mat[i1,j1]:5:2,s1);
              s:=s+s1;
            end;
            s:=s+'),';
          end;
          delete(s,length(s),1);
          listbox4.items.add(s);
          listbox4.ItemIndex:=nb_sol;
          nb_sol:=nb_sol+1;
          if (nb_sol > 500) then begin
            erreur('Too many found cells!!');
            exit;
          end;
          chaine[nb_sol]:=s;
          indic[nb_sol]:=no_psys;
      end;
    end;
  end;

//Classement
  if (nb_sol = 1)then begin
    listbox4.Items.add('No other cell');
    beep;
    screen.cursor:=crdefault;
    exit;
  end;
  listbox4.Clear;

//Elimination des solutions multiples
  if (radiogroup1.itemindex = 1) and (nb_sol > 2)then begin
     for i:=2 to nb_sol-1 do begin
       if(indic[i] = 0)then continue;
       s:=copy(chaine[i],5,44);
       dec(s,maille,no,ier);
       for j:=i+1 to nb_sol do begin
         if (indic[j] = 0)then continue;
         s:=copy(chaine[j],5,44);
         dec(s,maille2,no,ier);
         if(abs(maille[1]-maille2[1])<epsb) and (abs(maille[2]-maille2[2])<epsb)
         and (abs(maille[3]-maille2[3])<epsb) and
           (abs(maille[4]-maille2[4])<epsa) and (abs(maille[5]-maille2[5])<epsa)
         and (abs(maille[6]-maille2[6])<epsa) then indic[j]:=0;
       end;
     end;
  end;

  n:=1;
  for i:=1 to 7 do begin
    for j:=1 to nb_sol do begin
        if (indic[j] = i)then begin
           s:=chaine[j];
           verifie_sum(s,i1);
           str(i1:3,s1);
           if(i1 > 0)then s:=s+s1+'  ' else s:=s+'     ';
           n:=n+1;
           str(n-1:3,s1);
           s:=s+s1;
           listbox4.items.add(s);
        end;
    end;
  end;
  nb_sol:=n;
  screen.cursor:=crdefault;
  beep;
  color95button1.visible:=true;

//Ecriture de la maille de dpart
  i:=ftruecell.listbox1.itemIndex;
  n:=1;
  s:=ftruecell.listbox1.items[i];
  str(n:3,s1);s:=s+s1;
  fsupple.listbox4.clear;
  fsupple.listbox4.Items.add(s);
  s1:=copy(s,5,3);
  i20:=strtoint(s1);

  for i:=0 to nb_sol-2 do begin
      s:=ftruecell.listbox4.items[i];

//Mailles nouvelles trouves par Truecell (longueur de ligne = 118)
      s1:=copy(s,116,3);
      if(s1 = '   ')then begin
        compose_ligne(s);
        n:=n+1;
        str(n:3,s1);s:=s+s1;
        fsupple.listbox4.items.add(s);
        continue;
      end;

//Maille existantes
      nb_sum:=strtoint(s1);
      for j:=1 to nb_sol_crysfire do begin
        s1:=copy(ftruecell.listbox1.items[j],1,4);
        k:=strtoint(s1);
        if (k = nb_sum)then begin
          s:=ftruecell.listbox1.items[j];
          n:=n+1;
          str(n:3,s1);s:=s+s1;
          fsupple.listbox4.items.add(s);
          break;
        end;
      end;
    end;

//Etablissement de la structure crysum_truecel
   for i:=1 to nb_sol do begin
     s:=fsupple.listbox4.items[i-1];
     dec(s,maille2,no,ier);
     with crysum_truecell[i] do begin
       liste:=s;
       num:=round(maille2[1]);
       i20:=round(maille2[2]);
       fom:=maille2[3];
       vv1:=maille2[4];
       no_truecell:=i;
       for j:=1 to 6 do begin
         maille[j]:=maille2[j+4];
         cel[j]:=maille2[j+4];
       end;
       quel_systeme;
       syst:=systeme;
       vol:=maille2[11];
     end;
   end;

end;

procedure Tftruecell.cherche_best_sol(Sender: TObject);
//--------------------------------------------------
begin
  fsupple.show;
end;

procedure Tftruecell.on_click_lischeckbox(Sender: TObject);
//-----------------------------------------------------
var
  i              : integer;
begin
  with checklistbox1 do begin
    if (itemindex = 0) then begin
      for i:=1 to 6 do state[i]:=cbunchecked;
      state[0]:=cbchecked;
    end else begin
      state[0]:=cbunchecked;
    end;
  end;
end;

procedure Tftruecell.onexitcheck(Sender: TObject);
//------------------------------------------------
begin
  checklistbox1.itemindex:=-1;
end;

procedure Tftruecell.ListBox1Click(Sender: TObject);
//---------------------------------------------------
begin
  with fsupple do begin
    listbox4.clear;
    listbox2.clear;
    color95button1.visible:=false;
    panel2.visible:=false;
  end;
  listbox4.Clear;
end;

procedure Tftruecell.BitBtn10Click(Sender: TObject);
//--------------------------------------------------
var
   s               : string;
   maille          : tab_reel;
   no,ier,i        : integer;
begin
    if (listbox1.itemIndex = -1)then exit;
    s:=listbox1.items[listbox1.itemIndex];
    dec(s,maille,no,ier);
    fom_sol:=maille[3];
    for i:=1 to 6 do begin
      cel[i]:=maille[i+4];
      cel_depart[i]:=maille[i+4];
    end;
    quel_systeme;
    listbox1.itemindex:=-1;
    fsupercell.bitbtn2.visible:=false;
    //fsupercell.bitbtn4.visible:=false; Bouton ADD
    fsupercell.visible:=true;
end;

procedure Tftruecell.BitBtn1Click(Sender: TObject);
//--------------------------------------------------
 var
   s               : string;
   maille          : tab_reel;
   no,ier,i        : integer;
begin
    if (listbox4.itemIndex = -1)then begin
      beep;
      erreur('No solution selected');
      exit;
    end;
    s:=listbox4.items[listbox4.itemIndex];
    systeme:=trim(copy(s,1,4));
    delete(s,1,4);
    s:=trim(s);
    dec(s,maille,no,ier);
    for i:=1 to 6 do cel[i]:=maille[i];
    listbox4.itemindex:=-1;
    fsupercell.bitbtn2.visible:=false;
//  fsupercell.bitbtn4.visible:=false;
    fsupercell.visible:=true;
end;

procedure Tftruecell.calcule_densite(Sender: TObject);
//----------------------------------------------------
var
  i    : integer;
  s    : string;
begin
  if (nb_sol <= 0) then begin
      beep;
      erreur('No cell');
      exit;
  end;
  form70.visible:=true;
  form70.listbox1.clear;
  form70.Label14.caption:='';
  s:='Syst.   a      b      c    alpha  beta   gamma     V ';
  form70.listbox1.items.add(s);
  for i:=0 to nb_sol-2 do begin
    s:=copy(listbox4.items[i],1,54);
    form70.listbox1.items.add(s);
  end;
  nombre_mailles:=nb_sol-1;
  provenance:='truecell';
end;

end.
