unit unit3b;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages,forms,
  Controls, StdCtrls, dialogs, math;
var
// Conditions d'extinction  (nb_ligne_code)
   ligne_codeEN                                 : array[1..10] of string[40];
   nb_ligne_code                                : integer;
   nb_condition_si                              : array[1..6] of integer;
   no_condition_si                              : array[1..6,1..5] of integer;
   no_action_do                                 : array[1..6] of integer;

Procedure decode_conditions(var ier:integer);
procedure extinc(var ih,ik,il: integer; var ib:integer);
procedure indx;

implementation

uses mathhkl,unit1,unit6;

//Dcodage des conditions d'extinction du groupe de symtrie (code Enraf-Nonius)
Procedure decode_conditions(var ier:integer);{
---------------------------------------------}
 var
   il,i,j,k                        : integer;
   s,s1                            : string;
   nomf                            : TextFile;

 const
   condition_si : array[1..18] of string =
   ('H=0','H<0','H>K','H>L','K=0','K<0','K>L','K>H','L=0','L<0','L>H','L>K',
   'H=K','K=L','L=H','H=-K','K=-L','L=-H');

   action_do : array[1..29] of string =
   ('HN2','HN4','HN3','AH>AK','AH>AL','H+KN2','-HKLN3','KN2','KN4','KN3',
   'AK>AL','AK>AH','K+LN2','H-KLN3','LN2','LN4','LN3','AL>AH','AL>AK','L+HN2',
   'HK-LN3','HKLN2','H+KN4','K+LN4','L+HN4','2H+LN4','2K+HN4','2L+KN4','LN6');

 begin

   groupe_espace:=trimright(groupe_espace);

//Lecture des conditions d'extinction
   s:=repertoire_origine+'\'+systeme+'.pos';
   if (systeme ='QUAD')then s:=repertoire_origine+'\'+'TETR.pos';
   modif_attrib(s);
   AssignFile(nomf,s);
   Reset(nomf);
   ier:=1;
   while not(eof(nomf)) do begin
     readln(nomf,s);
     if (s = '')then continue;
     s:=trim(s);
     if (groupe_espace = 'NO EXT.')then begin
       groupe_espace:=s;
       nb_ligne_code:=0;
       ier:=0;
       break;
     end;
     if (s = groupe_espace) then begin
       ier:=0;
       readln(nomf,nb_ligne_code);                     //Conditions d'extinction
       if (nb_ligne_code > 0)then begin
         for i:=1 to nb_ligne_code do begin
           readln(nomf,s1);
           ligne_codeEN[i]:=s1;
         end;
       end;
       break;
     end;
   end;
   if (ier = 1)then begin
     erreur('Space group not found!');
     CloseFile(nomf);
     exit;
   end;
   CloseFile(nomf);

   //Dcodage des conditions d'extinction
   if (nb_ligne_code = 0)then exit;
   for il:=1 to nb_ligne_code do begin

      // Conditions Si
      nb_condition_si[il]:=0;
      s:=ligne_codeEN[il];
      s:=trimright(s);s:=trimleft(s);
      for i:=1 to 6 do begin   // 6 actions DO possibles?!
        if (pos('>',s) = 0) and (pos('<',s) = 0) and (pos('=',s) = 0)then break;
        j:=pos(' ',s);
        if (j = 0)then break;
        s1:=copy(s,1,j-1);s1:=trimleft(s1);
        delete(s,1,j);s:=trimright(s);s:=trimleft(s);
        ier:=1;
        for k:=1 to 18 do begin
          if (s1 = condition_si[k]) then begin
            nb_condition_si[il]:=nb_condition_si[il]+1;
            no_condition_si[il,nb_condition_si[il]]:=k;
            ier:=0;
            break;
          end;
        end;
        if (ier = 1) then begin
          erreur('Unknown condition:'+s1);
//        closeFile(nomf);
          exit;
        end;
      end;

      //Action DO
      s:=trim(s);
      ier:=1;
      for i:=1 to 29 do begin
        if (s = action_do[i])then begin
          no_action_do[il]:=i;
          ier:=0;
          break;
        end;
      end;
   end;
   if (ier = 1) then begin
     erreur('Unknown condition: '+s);
     exit;
   end;

end;

procedure extin2(ih,ik,il: integer; var ier: integer);{
------------------------------------------------------}
var
i,j,jer     :integer;

begin
{Coonditions 'SI'}
  ier:=0;
  if (nb_ligne_code = 0)then exit;
  for i:=1 to nb_ligne_code do begin
    jer:=0;
    for j:=1 to nb_condition_si[i] do begin
        case no_condition_si[i,j] of
          1: if (ih <> 0)then jer:=1;
          2: if (ih > 0 )then jer:=1;
          3: if (ih < ik)then jer:=1;
          4: if (ih < il)then jer:=1;
          5: if (ik <> 0)then jer:=1;
          6: if (ik > 0 )then jer:=1;
          7: if (ik < il)then jer:=1;
          8: if (ik < ih)then jer:=1;
          9: if (il <> 0)then jer:=1;
          10:if (il >= 0)then jer:=1;
          11:if (il <= ih)then jer:=1;
          12:if (il <= ik)then jer:=1;
          13:if (ih <> ik)then jer:=1;
          14:if (ik <> il)then jer:=1;
          15:if (il <> ih)then jer:=1;
          16:if (ih <>-ik)then jer:=1;
          17:if (ik <>-il)then jer:=1;
          18:if (il <>-ih)then jer:=1;
        end
      end;

      {jer:=1 les conditions "SI" de la commande ne sont pas satisfaites}
      if(jer = 1)then continue;

      {Action DO}
      ier:=0;
      case no_action_do[i] of
        1:  if( (ih mod 2) <> 0 ) then ier:=1;
        2:  if( (ih mod 4) <> 0 ) then ier:=1;
        3:  if( (ih mod 3) <> 0 ) then ier:=1 ;
        4:  if( abs(ih) > abs(ik) ) then ier:=1;
        5:  if( abs(ih) > abs(il) ) then ier:=1;
        6:  if( ((ih+ik) mod 2) <> 0 ) then ier:=1;
        7:  if( ((-ih+ik+il) mod 3) <> 0 ) then ier:=1;
        8:  if( (ik mod 2) <> 0 ) then ier:=1;
        9:  if( (ik mod 4) <> 0 ) then ier:=1;
        10: if( (ik mod 3) <> 0 ) then ier:=1;
        11: if( abs(ik) > abs(il)) then ier:=1;
        12: if( abs(ik) > abs(ih)) then ier:=1;
        13: if( ((ik+il) mod 2) <> 0 ) then ier:=1;
        14: if( ((ih-ik+il) mod 3) <> 0 ) then ier:=1;
        15: if( (il mod 2) <> 0 ) then ier:=1;
        16: if( (il mod 4) <> 0 ) then ier:=1;
        17: if( (il mod 3) <> 0 ) then ier:=1;
        18: if( abs(il) > abs(ih) ) then ier:=1;
        19: if( abs(il) > abs(ik) ) then ier:=1;
        20: if( ((il+ih) mod 2) <> 0 ) then ier:=1;
        21: if( ((ih+ik-il) mod 3) <> 0 ) then ier:=1;
        22: if( ((ih+ik+il) mod 2) <> 0 ) then ier:=1;
        23: if( ((ih+ik) mod 4) <> 0 ) then ier:=1;
        24: if( ((ik+il) mod 4) <> 0 ) then ier:=1;
        25: if( ((il+ih) mod 4) <> 0 ) then ier:=1;
        26: if( ((2*ih+il) mod 4) <> 0 ) then ier:=1;
        27: if( ((2*ik+ih) mod 4) <> 0 ) then ier:=1;
        28: if( ((2*il+ik) mod 4) <> 0 ) then ier:=1;
      end;
      if (ier = 1) then exit;
    end;

end;

{Extinctions du rseau de Bravais + extinctions du groupe.
(ib:=0 : c'est bon)}
procedure extinc(var ih,ik,il: integer; var ib:integer);{
----------------------------------------------------}
var
  is1,is2,is3,isom1,i           : integer;
  ibon,ibrav                    : integer;
begin
  if(ih = 0) and (ik = 0) and (il = 0)then begin
    ib:=1;
    exit;
  end;
  ibrav:=ord(bravais[1]);
  if (systeme = 'HEXA') and (copy(groupe_espace,1,1) = 'R')then ibrav:=82;
  ib:=1;
  case ibrav of
   80:                                  {Primitif}
      ib:=0;
   73:                                  {Corps centr}
      if( ((ih+ik+il) mod 2) = 0) then ib:=0;
   70:                                  {Faces centres}
      begin
        is1:=ih+ik;
        is2:=ik+il;
        is3:=il+ih;
        isom1:=abs(is1 mod 2)+abs(is2 mod 2)+abs(is3 mod 2);
        if( isom1 = 0 )then ib:=0;
      end;
    65:
      if ((ik+il) mod 2) = 0 then ib:=0; {Face A centre}
    66:
      if ((il+ih) mod 2) = 0 then ib:=0; {Face B centre}
    67:
      if ((ih+ik) mod 2) = 0 then ib:=0; {Face C centre}
    82:                                  {Rhombodrique index en Hexagonal}
      begin
        //if (systeme = 'HEXA') and (((-ih+ik+il) mod 3) = 0) then ib:=0;
        //if (systeme = 'HEXA') and (((ih-ik+il) mod 3) = 0) then ib:=0;
        if (systeme = 'HEXA')then begin
          if ( ((-ih+ik+il) mod 3) = 0) then ib:=0;
          if ( ((ih-ik+il) mod 3) = 0) then begin
            i:=ih;
            ih:=ik;
            ik:=i;
            ib:=0;
          end;
        end;
        if (systeme = 'RHOM') then ib:=0;
      end;
  end;
  if(ib = 0) and (nb_ligne_code > 0) then begin
    if (systeme = 'HEXA')then begin
       i:=-(ih+ik);
       extin2(ih,ik,il,ibon);
       if (ibon = 0)then extin2(i,ih,il,ibon);
       if (ibon = 0)then extin2(ik,i,il,ibon);
       if (ibon = 0)then extin2(ik,ih,il,ibon);
       if (ibon = 0)then extin2(i,ik,il,ibon);
       if (ibon = 0)then extin2(ih,i,il,ibon);
    end else begin 
       extin2(ih,ik,il,ibon);
    end;
    ib:=ibon;
  end;
end;

{$i equivalentes.pas}

procedure indx;{
---------------}
var
  h_groupe,k_groupe,l_groupe                           : integer;
  i,j,h,k,l,h1,h2,k1,k2,l1,l2,ier,ih,ik,il,n           : integer;
  hh,kk,ll,hmax,kmax,lmax                              : integer;
  x,y,z,r2hkl,lbds2,dhkl,xx                            : real;
  r2hkl_min,r2hkl_max,sithl                            : real;
  nr                                                   : integer;
  result                                               : array[1..10000] of ^raie;
  buf                                                  : raie;
  xlp,theta_rad,echel                                  : real;
  r1,r2,r3                                             : real;
begin
  form6.speedbutton2.down:=true;
  //screen.cursor:=crhourglass;
  bravais:=copy(groupe_espace,1,1);
  if(systeme = 'HEXA')then bravais:='P';

  decode_conditions(ier);
  if (ier = 1)then exit;

// limites des boucles
  setmat;
  xx:=2*sin(theta_max_depart/(57.2957*2))/lambda;

//22 mai 20002: Nouveau calcul des limites d'indices (voir Cranswick)
  h:=1;
  h2:=0;
  for k:=0 to 1 do begin
    for l:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= h2)then h2:=i;
    end;
  end;
  h2:=h2+2;

  k:=1;
  k2:=0;
  for h:=0 to 1 do begin
    for l:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= k2)then k2:=i;
    end;
  end;
  k2:=k2+2;

  l:=1;
  l2:=0;
  for h:=0 to 1 do begin
    for k:=0 to 1 do begin
      x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
      y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
      z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
      r2hkl:=sqrt(x*x+y*y+z*z);
      i:=round(xx/r2hkl);
      if (i >= l2)then l2:=i;
    end;
  end;
  l2:=l2+2;

  h1:=-h2;
  k1:=-k2;
  l1:=0;

  lbds2:=lambda/2;
  r2hkl_min:=2*sin(theta_min_depart/114.5914)/lambda;
  r2hkl_min:=(r2hkl_min*r2hkl_min);
  if (theta_min_depart < 0)then r2hkl_min:=0;
  r2hkl_max:=2*sin(theta_max_depart/114.5914)/lambda;
  r2hkl_max:=(r2hkl_max*r2hkl_max);

  nb_raies_indx_eteint:=0;
  nb_somme:=0;

  nb_raies_indx:=0;
  if (systeme = 'CUBI')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=k to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);

          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=ih;
            kr:=ik;
            lr:=il;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'TETR')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=ih;
            kr:=ik;
            lr:=il;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'ORTH')then begin
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=ih;
            kr:=ik;
            lr:=il;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'HEXA')then begin
    for h:=0 to h2 do begin
      for k:=h to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=ih;
            kr:=ik;
            lr:=il;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'RHOM')then begin
    for h:=0 to h2 do begin
      for k:=h to h2 do begin
        for l:=-h2 to h2 do begin
          if (h = 0) and (k = 0)  and (l = 0) then continue;
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=ih;
            kr:=ik;
            lr:=il;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'MONO')then begin
    for h:=h2 downto -h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=ih;
            kr:=ik;
            lr:=il;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 'TRIC')then begin
    for h:=-h2 to h2 do begin
      for k:=-k2 to k2 do begin
        for l:=0 to l2 do begin
          ih:=h;
          ik:=k;
          il:=l;
          extinc(ih,ik,il,ier);
          if (ier = 1)then continue;
          x:=r21[1,1]*ih+r21[1,2]*ik+r21[1,3]*il;
          y:=r21[2,1]*ih+r21[2,2]*ik+r21[2,3]*il;
          z:=r21[3,1]*ih+r21[3,2]*ik+r21[3,3]*il;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=ih;
            kr:=ik;
            lr:=il;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

//Mise en ordre
  for i:=1 to nb_raies_indx-1 do begin
    for j:=i+1 to nb_raies_indx do begin
      if (result[i]^.dr < result[j]^.dr) then begin
        buf:=result[j]^;
        result[j]^:=result[i]^;
        result[i]^:=buf;
      end;
    end;
  end;

  for i:=1 to nb_raies_indx do begin
    with raies_indx[i] do begin
      hr:=result[i]^.hr;
      kr:=result[i]^.kr;
      lr:=result[i]^.lr;
      dr:=result[i]^.dr;
      ext:=0;
      dtheta:=114.59159*arcsin(lambda/(2*dr));
    end;
    dispose(result[i]);
  end;


//Dtection des raies quivalentes
  for i:=1 to nb_raies_indx-1 do begin
    for j:=i+1 to nb_raies_indx do begin
      if (raies_indx[j].dr = 0) then continue;
      if (abs(raies_indx[i].dr-raies_indx[j].dr) < 0.0001)then begin
        with raies_indx[i] do begin
          h1:=hr;
          k1:=kr;
          l1:=lr;
        end;
        with raies_indx[j] do begin
          h2:=hr;
          k2:=kr;
          l2:=lr;
        end;
        ier:=0;
        equivalentes (h1,k1,l1,h2,k2,l2,ier);
        if (ier = 1) then begin
           raies_indx[j].dr:=0;
           continue;
        end;
      end;
    end;
  end;
  n:=0;
  for i:=1 to nb_raies_indx do begin
      if (raies_indx[i].dr = 0)then continue;
      n:=n+1;
      raies_indx[n]:=raies_indx[i];
  end;
  nb_raies_indx:=n;

end;



end.
